Rich text data is an anonymous object,you should follow the JSON Schema.
You can set the value for the specified cell in the specified sheet area using the following code:
You can get the unformatted data from the specified cell in the specified sheet area using the following code:
window.onload = function () {
var spread = new GC.Spread.Sheets.Workbook(document.getElementById("ss"), {sheetCount: 1});
initSpread(spread);
setOption(spread);
};
function initSpread(spread) {
var lawOfUniversalGravitation = {
richText: [
{
style: {
font: "normal 24px Calibri"
},
text: "F = (G * M"
},
{
style: {
font: "normal 24px Calibri",
vertAlign: 2
},
text: "1"
},
{
style: {
font: "normal 24px Calibri"
},
text: " * M"
},
{
style: {
font: "normal 24px Calibri",
vertAlign: 2
},
text: "2"
},
{
style: {
font: "normal 24px Calibri"
},
text: ") / R"
},
{
style: {
font: "normal 24px Calibri",
vertAlign: 1
},
text: "2"
}
]
};
var reaction = {
richText: [
{
style: {
font: "normal 24px Calibri"
},
text: "3 Ba(OH)"
},
{
style: {
font: "normal 24px Calibri",
vertAlign: 2
},
text: "2"
},
{
style: {
font: "normal 24px Calibri"
},
text: " + 2 H"
},
{
style: {
font: "normal 24px Calibri",
vertAlign: 2
},
text: "3"
},
{
style: {
font: "normal 24px Calibri"
},
text: "PO"
},
{
style: {
font: "normal 24px Calibri",
vertAlign: 2
},
text: "4"
},
{
style: {
font: "normal 24px Calibri"
},
text: " → 6 H"
},
{
style: {
font: "normal 24px Calibri",
vertAlign: 2
},
text: "2"
},
{
style: {
font: "normal 24px Calibri"
},
text: "O + Ba"
},
{
style: {
font: "normal 24px Calibri",
vertAlign: 2
},
text: "3"
},
{
style: {
font: "normal 24px Calibri"
},
text: "(PO"
},
{
style: {
font: "normal 24px Calibri",
vertAlign: 2
},
text: "4"
},
{
style: {
font: "normal 24px Calibri"
},
text: ")"
},
{
style: {
font: "normal 24px Calibri",
vertAlign: 2
},
text: "2"
},
{
style: {
font: "normal 24px Calibri"
},
text: "↓"
}
]
};
var google = {
richText: [
{
style: {
font: "bold 36px Calibri",
foreColor: "rgb(78,133,242)"
},
text: "G"
},
{
style: {
font: "bold 36px Calibri",
foreColor: "rgb(228,65,52)"
},
text: "o"
},
{
style: {
font: "bold 36px Calibri",
foreColor: "rgb(247,188,32)"
},
text: "o"
},
{
style: {
font: "bold 36px Calibri",
foreColor: "rgb(78,133,242)"
},
text: "g"
},
{
style: {
font: "bold 36px Calibri",
foreColor: "rgb(65,168,87)"
},
text: "l"
},
{
style: {
font: "bold 36px Calibri",
foreColor: "rgb(228,65,52)"
},
text: "e"
}
]
};
var sheet = spread.sheets[0];
sheet.suspendPaint();
sheet.setColumnWidth(0, 720);
sheet.setValue(0, 0, 'Law of universal gravitation:', 3);
sheet.setValue(1, 0, lawOfUniversalGravitation, 3);
sheet.setRowHeight(1, 40);
sheet.getCell(1, 0).vAlign(GC.Spread.Sheets.VerticalAlign.center);
sheet.setValue(3, 0, 'The reaction of barium hydroxide with phosphoric acid:', 3);
sheet.setValue(4, 0, reaction, 3);
sheet.setRowHeight(4, 40);
sheet.getCell(4, 0).vAlign(GC.Spread.Sheets.VerticalAlign.center);
sheet.setValue(6, 0, google, 3);
sheet.setRowHeight(6, 50);
sheet.name('Basic Usage');
sheet.resumePaint();
spread.options.tabStripRatio = 0.8;
}
function setOption(spread) {
var _extends = Object.assign || function (target) {
for (var i = 1; i < arguments.length; i++) {
var source = arguments[i];
for (var key in source) {
if (Object.prototype.hasOwnProperty.call(source, key)) {
target[key] = source[key];
}
}
}
return target;
};
var addEventListener = function (parent, type, listener) {
return parent.addEventListener(type, listener);
};
var appendChild = function (parent, child) {
return parent.appendChild(child);
};
var createElement = function (tag) {
return document.createElement(tag);
};
var queryCommandState = function (command) {
return document.queryCommandState(command);
};
var queryCommandValue = function (command) {
return document.queryCommandValue(command);
};
var defaultClasses = {
actionbar: 'rich-editor-actionbar',
button: 'rich-editor-button',
content: 'rich-editor-content',
selected: 'rich-editor-button-selected'
};
var defaultParagraphSeparatorString = 'defaultParagraphSeparator';
var formatBlock = 'formatBlock';
var exec = function (command) {
var value = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
return document.execCommand(command, false, value);
};
// font element limitation, only support font size from 1~7
var convertFontSize = function (value) {
if (value <= 10) {
return 1;
} else if (value <= 13) {
return 2;
} else if (value <= 16) {
return 3;
} else if (value <= 18) {
return 4;
} else if (value <= 24) {
return 5;
} else if (value <= 32) {
return 6;
} else {
return 7;
}
};
var fontSizeDict = [0, 10, 13, 16, 18, 24, 32, 48];
var _stopBubble = function (e) {
if (e && e.stopPropagation) {
e.stopPropagation();
} else {
window.event.cancelBubble = true;
}
};
var _colorRGB2Hex = function (color) {
var rgb = color.split(',');
var r = parseInt(rgb[0].split('(')[1]);
var g = parseInt(rgb[1]);
var b = parseInt(rgb[2].split(')')[0]);
return "#" + ((1 << 24) + (r << 16) + (g << 8) + b).toString(16).slice(1);
};
var createRichTextElement = function (tag, value) {
var elem;
switch (tag) {
case 'subscript':
elem = createElement('sub');
break;
case 'superscript':
elem = createElement('sup');
break;
case 'underline':
elem = createElement('u');
break;
case 'strikeThrough':
elem = createElement('strike');
break;
case 'foreColor':
elem = createElement('font');
elem.color = _colorRGB2Hex(value);
break;
case 'fontName':
elem = createElement('font');
elem.face = value;
break;
case 'fontSize':
elem = createElement('font');
elem.size = convertFontSize(value);
break;
case 'bold':
elem = createElement('b');
break;
case 'italic':
elem = createElement('i');
break;
default:
elem = createElement('span');
break;
}
return elem;
};
var addFonts = function (container) {
var defaultFonts = {
ff1: {name: "Arial", text: "Arial"},
ff2: {name: "Arial Black", text: "Arial Black"},
ff3: {name: "Calibri", text: "Calibri"},
ff4: {name: "Cambria", text: "Cambria"},
ff5: {name: "Candara", text: "Candara"},
ff6: {name: "Century", text: "Century"},
ff7: {name: "Courier New", text: "Courier New"},
ff8: {name: "Comic Sans MS", text: "Comic Sans MS"},
ff9: {name: "Garamond", text: "Garamond"},
ff10: {name: "Georgia", text: "Georgia"},
ff11: {name: "Malgun Gothic", text: "Malgun Gothic"},
ff12: {name: "Mangal", text: "Mangal"},
ff13: {name: "Meiryo", text: "Meiryo"},
ff14: {name: "MS Gothic", text: "MS Gothic"},
ff15: {name: "MS Mincho", text: "MS Mincho"},
ff16: {name: "MS PGothic", text: "MS PGothic"},
ff17: {name: "MS PMincho", text: "MS PMincho"},
ff18: {name: "Tahoma", text: "Tahoma"},
ff19: {name: "Times", text: "Times"},
ff20: {name: "Times New Roman", text: "Times New Roman"},
ff21: {name: "Trebuchet MS", text: "Trebuchet MS"},
ff22: {name: "Verdana", text: "Verdana"},
ff23: {name: "Wingdings", text: "Wingdings"}
};
var $ul = container;
var fontItems = [];
var prefix = 'ff', i = 1, id = prefix + i;
while (defaultFonts[id]) {
fontItems.push(('<li class="fontfamily-item">' +
defaultFonts[id].name +
'</li>'));
// .replace(/\{id\}/g, id));
i++;
id = prefix + i;
}
$ul.innerHTML += fontItems.join('');
};
var defaultActions = {
fontFamily: {
icon: '<span id="fontFamilyValue">Calibri</span>' +
'<span class="drop-down-arrow"></span>',
title: 'Bold',
type: 'drop-down',
specialStyle: {
width: '150px'
},
dropDownListId: 'fontFamilyList',
queryValue: function () {
var value = queryCommandValue('fontName').replace(/"/g, '');
if (value.length > 15) { // if fontFamily string is too long,
value = value.substring(0, 15) + '...';
}
document.getElementById('fontFamilyValue').innerText = value;
},
result: function (e) {
e.currentTarget.style.display = 'none';
_stopBubble(e);
var result = e.target.nodeName.toUpperCase() === 'LI' ? e.target.innerText : null;
if (result) {
document.getElementById('fontFamilyValue').innerText = result;
exec('fontName', result);
return true;
} else {
return false;
}
}
},
fontSize: {
icon: '<span id="fontSizeValue">13</span>' +
'<span class="drop-down-arrow"></span>',
title: 'Bold',
type: 'drop-down',
specialStyle: {
width: '40px'
},
dropDownListId: 'fontSizeList',
queryValue: function () {
var fontSizeMap = [0, 10, 13, 16, 18, 24, 32, 48];
var value = queryCommandValue('fontSize');
document.getElementById('fontSizeValue').innerText = fontSizeMap[value] ? fontSizeMap[value] : document.getElementById('fontSizeValue').innerText;
},
result: function (e) {
e.currentTarget.style.display = 'none';
_stopBubble(e);
var result = e.target.nodeName.toUpperCase() === 'LI' ? parseInt(e.target.value) : null;
if (result !== null) {
document.getElementById('fontSizeValue').innerText = fontSizeDict[result];
exec('fontSize', result);
return true;
} else {
return false;
}
}
},
bold: {
icon: '<b>B</b>',
title: 'Bold',
state: function () {
return queryCommandState('bold');
},
result: function () {
return exec('bold');
}
},
italic: {
icon: '<i>I</i>',
title: 'Italic',
state: function () {
return queryCommandState('italic');
},
result: function () {
return exec('italic');
}
},
underline: {
icon: '<u>U</u>',
title: 'Underline',
state: function () {
return queryCommandState('underline');
},
result: function () {
return exec('underline');
}
},
strikethrough: {
icon: '<strike>S</strike>',
title: 'Strike-through',
state: function () {
return queryCommandState('strikeThrough');
},
result: function () {
return exec('strikeThrough');
}
},
colorPicker: {
icon: '<span id="foreColorValue" class="color_picker_result"> A </span>' +
'<span class="drop-down-arrow"></span>',
title: 'colorPicker',
type: 'drop-down',
specialStyle: {
width: '40px'
},
dropDownListId: 'colorPicker',
queryValue: function () {
var value = queryCommandValue('foreColor');
document.getElementById('foreColorValue').style.borderBottomColor = value;
},
result: function result(e) {
e.currentTarget.style.display = 'none';
_stopBubble(e);
return e.target.nodeName.toUpperCase() === 'LI' ? exec('foreColor', _colorRGB2Hex(e.target.style.backgroundColor)) : false;
}
},
superScript: {
icon: 'X<sup>2</sup>',
title: 'SuperScript',
state: function () {
return queryCommandState('superscript');
},
result: function () {
return exec('superscript');
}
},
subScript: {
icon: 'X<sub>2</sub>',
title: 'SubScript',
state: function () {
return queryCommandState('subscript');
},
result: function () {
return exec('subscript');
}
}
};
function _getRichText() {
var iterator = document.createNodeIterator(document.getElementsByClassName('rich-editor-content')[0], NodeFilter.SHOW_ELEMENT | NodeFilter.SHOW_TEXT, null, false);
var root = iterator.nextNode();// root
var richText = [];
var style = {};
var text = '';
var node = iterator.nextNode();
var underlineNode = null, lineThroughNode = null, pNode = null;
while (node !== null) {
if (node.nodeType === 3/*TextNode*/) {
text = node.nodeValue;
style = document.defaultView.getComputedStyle(node.parentElement, null);
if (underlineNode && underlineNode.contains(node) === false) {
underlineNode = null;
}
if (lineThroughNode && lineThroughNode.contains(node) === false) {
lineThroughNode = null;
}
if (pNode && _getLastTextNode(pNode) === node && _getLastTextNode(root) !== node) {
text = text + '\r\n';
pNode = null;
}
var richTextStyle = _getRichStyle(style, underlineNode, lineThroughNode);
_handleSuperAndSubScript(root, node, richTextStyle);
richText.push({
style: richTextStyle,
text: text
});
} else if (node.nodeName.toLowerCase() === 'p') {
pNode = node;
} else if (node.nodeName.toLowerCase() === 'u') {
underlineNode = node;
} else if (node.nodeName.toLowerCase() === 'strike') {
lineThroughNode = node;
}
node = iterator.nextNode();
}
return richText;
};
function _handleSuperAndSubScript(root, node, style) {
if (root === node) {
return;
}
while (node.parentNode !== root) {
if (node.nodeName.toLowerCase() === 'sub') {
style.vertAlign = 2;
break;
}
if (node.nodeName.toLowerCase() === 'sup') {
style.vertAlign = 1;
break;
}
node = node.parentNode;
}
};
function _getRichStyle(style, isUnderlineNode, isLineThroughNode) {// getComputedStyle can't get inherit textDecoration
return {
font: (style.fontWeight === '700' ? 'bold ' : '') + (style.fontStyle === 'italic' ? 'italic ' : '') + style.fontSize + ' ' + style.fontFamily,
foreColor: style.color,
textDecoration: (isUnderlineNode ? 1 : 0) | (isLineThroughNode ? 2 : 0)
};
};
function _getLastTextNode (root) {
if (root && root.nodeType === 1) {
var child = root.lastChild;
return _getLastTextNode(child);
} else {
return root;
}
};
var _initContent = function(settings) {
var actions = settings.actions ? settings.actions.map(function (action) {
if (typeof action === 'string') {
return defaultActions[action];
}
else if (defaultActions[action.name]) { //NOSONAR
return _extends({}, defaultActions[action.name], action);
}
return action;
}) : Object.keys(defaultActions).map(function (action) {
return defaultActions[action];
});
var classes = _extends({}, defaultClasses, settings.classes);
var defaultParagraphSeparator = settings[defaultParagraphSeparatorString] || 'div';
var actionbar = createElement('div');
actionbar.className = classes.actionbar;
appendChild(settings.element, actionbar);
var content = settings.element.content = createElement('div');
content.contentEditable = true;
content.className = classes.content;
content.oninput = function (_ref) {
var firstChild = _ref.target.firstChild;
if (firstChild && firstChild.nodeType === 3) {
exec(formatBlock, '<' + defaultParagraphSeparator + '>');
} else if (content.innerHTML === '<br>') {//NOSONAR
content.innerHTML = '';
}
};
content.onkeydown = function (event) {
if (event.key === 'Tab') {
event.preventDefault();
} else if (event.key === 'Enter' && queryCommandValue(formatBlock) === 'blockquote') {
setTimeout(function () {
return exec(formatBlock, '<' + defaultParagraphSeparator + '>');
}, 0);
}
};
appendChild(settings.element, content);
var contentWrapper = createElement(defaultParagraphSeparator);
appendChild(content, contentWrapper);
if (!this._addedFonts) {
addFonts(document.querySelector("#fontFamilyList"));
this._addedFonts = true;
}
actions.forEach(function (action) {
var button = createElement('button');
button.className = classes.button;
button.innerHTML = action.icon;
// button.title = action.title;
if (action.specialStyle) {
for (var styleProp in action.specialStyle) {
if (action.specialStyle.hasOwnProperty(styleProp)) {
button.style[styleProp] = action.specialStyle[styleProp];
}
}
}
button.setAttribute('type', 'button');
button.onclick = function () {
// should notify each action button to close its drop-down list.
var lists = document.getElementsByClassName('list');
var dropDownList = document.getElementById(action.dropDownListId);
for (var k = 0; k < lists.length; k++) {
if (lists[k] !== dropDownList) {
lists[k].style.display = 'none';
}
}
if (action.type === 'drop-down') {
if (button.contains(dropDownList)) {
dropDownList.style.display === 'none' ? (dropDownList.style.display = 'block') : (dropDownList.style.display = 'none'); //NOSONAR
} else {
var dropDownListClone = dropDownList.cloneNode(true);
if (action.queryValue) {
addEventListener(dropDownListClone, 'click', action.queryValue);
}
button.appendChild(dropDownListClone);
var hostOffsetHeight = button.offsetHeight;
dropDownListClone.style.top = hostOffsetHeight + 'px';
dropDownListClone.style.display = 'block';
dropDownListClone.onclick = function (e) {
return action.result(e) && content.focus();
};
}
} else if (action.type === 'designer-gcui-widget') {
document.querySelector(action.widgetId).toggle();
} else {
return action.result() && content.focus();
}
};
var handler;
if (action.state) {
handler = function () {
return button.classList[action.state() ? 'add' : 'remove'](classes.selected);
};
addEventListener(content, 'keyup', handler);
addEventListener(content, 'mouseup', handler);
addEventListener(button, 'click', handler);
}
if (action.queryValue) {
handler = action.queryValue;
addEventListener(content, 'keyup', handler);
addEventListener(content, 'mouseup', handler);
addEventListener(button, 'click', handler);
}
appendChild(actionbar, button);
});
if (settings.styleWithCSS) {
exec('styleWithCSS');
}
exec(defaultParagraphSeparatorString, defaultParagraphSeparator);
return settings.element;
}
var richEditor = {exec: exec, init: _initContent};
spread.bind(GC.Spread.Sheets.Events.EnterCell, onSpreadEnterCell);
function onSpreadEnterCell(){
var sheet = spread.getActiveSheet();
var contentWrapper = document.querySelector('.rich-editor-content');
contentWrapper.innerHTML="";
var contentText = sheet.getValue(sheet.getActiveRowIndex(), sheet.getActiveColumnIndex(), 3/* sheetArea */, 1/* richText */);
if (contentText && contentText.richText) {
for (var i = 0; i < contentText.richText.length; i++) {
var elemAttr = [];
if (contentText.richText[i].style && contentText.richText[i].text) {
for (var styleProperty in contentText.richText[i].style) {
if (contentText.richText[i].style.hasOwnProperty(styleProperty)) {
switch (styleProperty) {
case 'vertAlign':
if (contentText.richText[i].style[styleProperty] === 2) {
elemAttr.push('subscript');
} else if (contentText.richText[i].style[styleProperty] === 1) {
elemAttr.push('superscript');
}
break;
case 'textDecoration':
if ((contentText.richText[i].style[styleProperty] & 1) === 1) {
elemAttr.push('underline');
}
if ((contentText.richText[i].style[styleProperty] & 2) === 2) {
elemAttr.push('strikeThrough');
}
break;
case 'foreColor':
elemAttr.push({
name: 'foreColor',
value: contentText.richText[i].style[styleProperty]
});
break;
case 'font':
var spanElem = createElement('div');
spanElem.style.font = contentText.richText[i].style[styleProperty];
if (spanElem.style.fontFamily) {
elemAttr.push({
name: 'fontName',
value: spanElem.style.fontFamily
});
}
if (spanElem.style.fontSize) {
elemAttr.push({
name: 'fontSize',
value: parseInt(spanElem.style.fontSize)
});
}
if (spanElem.style.fontWeight === 'bold') {
elemAttr.push('bold');
}
if (spanElem.style.fontStyle === 'italic') {
elemAttr.push('italic');
}
break;
}
}
}
}
var parentElem = contentWrapper;
for (var j = 0; j < elemAttr.length; j++) {
var richTextElem;
if (typeof elemAttr[j] === 'string') {
richTextElem = createRichTextElement(elemAttr[j]);
} else if (typeof elemAttr[j] === 'object' && elemAttr[j]) {
richTextElem = createRichTextElement(elemAttr[j].name, elemAttr[j].value);
}
appendChild(parentElem, richTextElem);
parentElem = richTextElem;
if (j === elemAttr.length - 1 && richTextElem) {
richTextElem.innerHTML = contentText.richText[i].text;
}
}
}
} else {
contentWrapper.innerHTML = contentText;
}
}
richEditor.init({
element: document.getElementById('richEditor'),
defaultParagraphSeparator: 'p',
styleWithCSS: false,
});
document.getElementById("setRichText").addEventListener("click", function () {
var spread =GC.Spread.Sheets.findControl("ss");
var sheet = spread.getActiveSheet();
var richText = _getRichText();
if (richText.length > 0) {
sheet.setValue(sheet.getActiveRowIndex(), sheet.getActiveColumnIndex(), {
richText: richText
});
}
});
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/purejs/node_modules/@grapecity/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/en/purejs/node_modules/@grapecity/spread-sheets/dist/gc.spread.sheets.all.min.js" type="text/javascript"></script>
<script src="$DEMOROOT$/spread/source/js/license.js" type="text/javascript"></script>
<script src="app.js" type="text/javascript"></script>
<link rel="stylesheet" type="text/css" href="styles.css">
</head>
<body>
<div class="sample-tutorial">
<div id="ss" class="sample-spreadsheets"></div>
<div class="options-container">
<div class="sp-demo-childBlock">
<div class="sp-demo-Header">
<strong class="sp-demo-HeaderTitle">Settings</strong>
</div>
<div id="settingsDiv">
<div id="richEditor" class="rich-editor"></div>
<ul id="fontSizeList" class="list">
<li class="fontsize-item" value='1'>10</li>
<li class="fontsize-item" value='2'>13</li>
<li class="fontsize-item" value='3'>16</li>
<li class="fontsize-item" value='4'>18</li>
<li class="fontsize-item" value='5'>24</li>
<li class="fontsize-item" value='6'>32</li>
<li class="fontsize-item" value='7'>48</li>
</ul>
<ul id="fontFamilyList" class="list fontfamily-list">
<li class="fontfamily-item">Segoe UI</li>
<li class="fontfamily-item">Arial</li>
<li class="fontfamily-item">Calibri</li>
<li class="fontfamily-item">Courier New</li>
<li class="fontfamily-item">Comic Sans MS</li>
<li class="fontfamily-item">Microsoft YaHei</li>
<li class="fontfamily-item">Times New Roman</li>
</ul>
<ul id="colorPicker" class="list">
<li class="colorpicker-item" style="background-color:#FFFFFF;"></li>
<li class="colorpicker-item" style="background-color: #C00000;"></li>
<li class="colorpicker-item" style="background-color: #FF0000;"></li>
<li class="colorpicker-item" style="background-color: #FFC003;"></li>
<li class="colorpicker-item" style="background-color: #FFFF00;"></li>
<li class="colorpicker-item" style="background-color: #94D051;"></li>
<li class="colorpicker-item" style="background-color: #00B050;"></li>
<li class="colorpicker-item" style="background-color: #00AFF0;"></li>
<li class="colorpicker-item" style="background-color: #006EC3;"></li>
<li class="colorpicker-item" style="background-color: #001E6E;"></li>
<li class="colorpicker-item" style="background-color: #6E32A0;"></li>
<li class="colorpicker-item" style="background-color: #000000;"></li>
</ul>
<button id="setRichText" value="Set Rich Text">Set Rich Text</button>
</div>
</div>
</div>
</div></body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
* {
margin: 0;
padding: 0;
}
.list {
list-style: none;
display: none;
position: absolute;
box-shadow: 1px 2px 5px 2px rgba(51, 51, 51, .15);
background-color: white;
}
.fontfamily-list{
overflow: scroll;
height: 200px;
}
.rich-editor {
border: 1px solid rgba(10, 10, 10, 0.1);
box-sizing: border-box;
background-color: white;
}
.rich-editor-content {
box-sizing: border-box;
height: 270px;
outline: 0;
overflow-y: auto;
padding: 10px;
}
#setRichText {
display: inline-block;
background-color: white;
border: none;
width: 120px;
height: 30px;
line-height: 30px;
margin-top: 5px;
box-shadow: 1px 2px 5px 2px rgba(51, 51, 51, .15);
}
.rich-editor-actionbar {
background-color: #FFF;
border-bottom: 1px solid rgba(10, 10, 10, 0.1);
}
.rich-editor-button {
background-color: transparent;
border: none;
cursor: pointer;
height: 30px;
line-height: 30px;
outline: 0;
width: 30px;
display: inline-block;
margin: 0 3px;
padding:0 2px;
}
.drop-down-arrow {
display: inline-block;
height: 30px;
line-height: 30px;
}
.drop-down-arrow:before {
display: block;
content: '';
width: 0;
border-width: 5px;
border-style: solid;
border-color: black transparent transparent transparent;
margin-top: 23px;
margin-left: 2px;
}
.rich-editor-button-selected {
background-color: #F0F0F0;
}
.color_picker_result {
border-bottom: 5px solid black;
}
#fontSizeList {
width: 40px;
}
#fontFamilyList {
width: 140px;
}
#colorPicker {
width: 70px;
}
.fontsize-item {
width: 40px;
height: 30px;
line-height: 30px;
text-align: center;
cursor: pointer;
}
.fontfamily-item {
width: 128px;
height: 30px;
line-height: 30px;
text-align: left;
padding-left: 13px;
cursor: pointer;
}
.colorpicker-item {
width: 16px;
height: 16px;
margin: 1px;
padding: 1px;
border: 1px solid transparent;
background-clip: content-box;
float: left;
display: inline-block;
}
.fontsize-item:hover {
background-color: #DDDDDDAA;
}
.fontfamily-item:hover {
background-color: #DDDDDDAA;
}
.colorpicker-item:hover {
box-shadow: 1px 1px 1px 1px rgba(51, 51, 51, .15);
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}

Rich text data is an anonymous object, you should follow the JSON Schema.
You can set the value for the specified cell in the specified sheet area using the following code:
You can get the unformatted data from the specified cell in the specified sheet area using the following code:
Updated: Rich text now support list
<template>
<div class="sample-tutorial">
<gc-spread-sheets-designer :styleInfo="styleInfo" :config="config" @designerInitialized="initDesigner" />
</div>
</template>
<script setup>
import GC from "@mescius/spread-sheets";
import { ref } from "vue";
import "@mescius/spread-sheets-print";
import "@mescius/spread-sheets-shapes";
import "@mescius/spread-sheets-pivot-addon";
import "@mescius/spread-sheets-tablesheet";
import '@mescius/spread-sheets-designer-resources-en';
import '@mescius/spread-sheets-designer'
import {registerlic} from '$DEMOROOT$/spread/source/js/designer/react_vue/license.js'
registerlic(GC);
GC.Spread.Common.CultureManager.culture("en-us");
const spreadNS = GC.Spread.Sheets;
const styleInfo = {
height: '100%'
}
const spreadRef = ref();
const richEditorHelper = {
toHexColor (color) {
let reg = /^#([0-9a-fA-F]{3}|[0-9a-fA-F]{6})$/;
if (/^(rgb|RGB)/.test(color)) {
let aColor = color.replace(/(?:\(|\)|rgb|RGB)*/g, "").split(",");
let strHex = "#";
for (let i = 0; i < aColor.length; i++) {
let hex = Number(aColor[i]).toString(16);
if (hex.length < 2) {
hex = '0' + hex;
}
strHex += hex;
}
if (strHex.length !== 7) {
strHex = color;
}
return strHex;
} else if (reg.test(color)) {
let aNum = color.replace(/#/, "").split("");
if (aNum.length === 6) {
return color;
} else if (aNum.length === 3) {
let numHex = "#";
for (let i = 0; i < aNum.length; i += 1) {
numHex += (aNum[i] + aNum[i]);
}
return numHex;
}
}
return color;
},
getStandardFont (unStandardFont) {
if (!unStandardFont) {
return;
}
let style = new spreadNS.Style();
style.font = unStandardFont;
let { fontWeight, fontSize } = style;
if (!isNaN(fontWeight)) {
style.fontWeight = +fontWeight >= 700 ? "bold" : "normal";
}
style.fontSize = (fontSize.indexOf("px") > 0) ? (Math.round((+(fontSize.split("px")[0])) * 3 / 4) + "pt") : fontSize;
return style.font;
},
setDefaultStyleToRichItem (richText, font, foreColor, textDecoration) {
richText.style = {
font,
foreColor,
textDecoration
};
},
isNullOrUndefined (value) {
return value === undefined || value === null;
},
composeCurrentRichItemStyleWithActiveCellStyle (richText, cellStyle, theme) {
const currentItemStyle = richText.style;
if (currentItemStyle.foreColor === undefined && !richEditorHelper.isNullOrUndefined(cellStyle.foreColor)) {
currentItemStyle.foreColor = cellStyle.foreColor;
}
if (currentItemStyle.font === undefined && !richEditorHelper.isNullOrUndefined(cellStyle.font)) {
currentItemStyle.font = cellStyle.font;
} else if (currentItemStyle.font) {
currentItemStyle.font = richEditorHelper.getStandardFont(currentItemStyle.font);
}
if (currentItemStyle.textDecoration === undefined && !richEditorHelper.isNullOrUndefined(cellStyle.textDecoration)) {
currentItemStyle.textDecoration = cellStyle.textDecoration;
}
currentItemStyle.foreColor = richEditorHelper.toHexColor(theme.getColor(currentItemStyle.foreColor));
},
splitRichTextByLineBreaker (richText, newRichTexts) {
const currentItemStyle = richText.style;
const wrappedTexts = richText.text.split(/\r?\n/g);
for (let j = 0, wrapperLen = wrappedTexts.length; j < wrapperLen; j++) {
let obj = {};
obj.text = wrappedTexts[j];
obj.style = currentItemStyle;
if (obj.text) {
newRichTexts.push(obj);
}
if (j !== wrapperLen - 1) {
newRichTexts.push({
text: '\r\n',
style: currentItemStyle
});
}
}
},
createRichTextsFromPlainText (sheet, row, col, font, foreColor, textDecoration) {
const text = sheet.getText(row, col);
const wrappedTexts = text.split("\n");
const richTexts = [];
for (let i = 0, len = wrappedTexts.length; i < len; i++) {
if (wrappedTexts[i]) {
richTexts.push({
text: wrappedTexts[i],
style: {
font,
foreColor,
textDecoration
}
});
}
if (i !== len - 1) {
richTexts.push({
text: '\r\n',
style: richTexts[i].style
});
}
}
return richTexts;
},
getRichStyleFromCellStyle (cellStyle, theme) {
return {
font: cellStyle.font,
textDecoration: cellStyle.textDecoration,
foreColor: cellStyle.foreColor
}
},
getRichTextItemsForRichEditor (sheet, row, col) {
const value = sheet.getValue(row, col, spreadNS.SheetArea.viewport, spreadNS.ValueType.richText);
const cellStyle = sheet.getActualStyle(row, col);
const theme = sheet.currentTheme();
if (cellStyle.foreColor && theme) {
cellStyle.foreColor = richEditorHelper.toHexColor(theme.getColor(cellStyle.foreColor));
}
if (!value) {
return [{
text: "",
style: richEditorHelper.getRichStyleFromCellStyle(cellStyle)
}];
}
let richTexts = value.richText;
let foreColor = cellStyle.foreColor || "#000000";
let textDecoration = cellStyle.textDecoration;
let font = cellStyle.font ? richEditorHelper.getStandardFont(cellStyle.font) : "11pt Calibri";
if (richTexts) {
let newRichTexts = [];
for (let i = 0, len = richTexts.length; i < len; i++) {
if (!richTexts[i]) {
continue;
}
if (!richTexts[i].style) {
richEditorHelper.setDefaultStyleToRichItem(richTexts[i], font, foreColor, textDecoration);
} else if (richTexts[i].style) {
richEditorHelper.composeCurrentRichItemStyleWithActiveCellStyle(richTexts[i], cellStyle, theme);
}
if (richTexts[i].text && richTexts[i].text !== "\r\n" && richTexts[i].text !== '\n' && richTexts[i].text.split(/\r?\n/g).length > 1) {
richEditorHelper.splitRichTextByLineBreaker(richTexts[i], newRichTexts);
} else {
newRichTexts.push(richTexts[i]);
}
}
return newRichTexts;
} else {
return richEditorHelper.createRichTextsFromPlainText(sheet, row, col, font, foreColor, textDecoration);
}
}
};
const getDesignerConfig = () => {
GC.Spread.Sheets.Designer.registerTemplate("richEditor", {
content: [{
type: "RichTextEditor",
bindingPath: "value",
editorWidth: "640px",
editorHeight: "542px",
onChange: (value, spread) => {
if (!spread || !value) {
return;
}
let sheet = spread.getActiveSheet();
sheet.setValue(sheet.getActiveRowIndex(), sheet.getActiveColumnIndex(), value.value);
}
}]
});
const richEditorPanel = {
position: "right",
width: "640px",
command: "richEditor",
uiTemplate: "richEditor"
};
let oldSheetName, oldRow, oldCol, oldValue;
const richEditorCommand = {
commandName: 'richEditor',
getState: (context) => {
const spread = context.getWorkbook(), activeSheet = spread.getActiveSheet(), activeRow = activeSheet.getActiveRowIndex(), activeCol = activeSheet.getActiveColumnIndex();
// only when change active cell, need to reset editor content
if (oldSheetName === activeSheet.name() && oldRow === activeRow && oldCol === activeCol) {
return oldValue;
}
oldSheetName = activeSheet.name();
oldRow = activeRow;
oldCol = activeCol;
const richTextItems = richEditorHelper.getRichTextItemsForRichEditor(activeSheet, activeRow, activeCol);
oldValue = {
value: {
value: {
richText: richTextItems
},
style: activeSheet.getActualStyle(activeRow, activeCol)
}
};
return oldValue;
}
}
return {
contextMenu: [],
ribbon: [],
sidePanels: [richEditorPanel],
commandMap: {
richEditor: richEditorCommand
}
};
};
const config = ref(getDesignerConfig());
const initSpread = (spread) => {
const lawOfUniversalGravitation = {
richText: [
{
style: {
font: "normal 24px Calibri"
},
text: "F = (G * M"
},
{
style: {
font: "normal 24px Calibri",
vertAlign: 2
},
text: "1"
},
{
style: {
font: "normal 24px Calibri"
},
text: " * M"
},
{
style: {
font: "normal 24px Calibri",
vertAlign: 2
},
text: "2"
},
{
style: {
font: "normal 24px Calibri"
},
text: ") / R"
},
{
style: {
font: "normal 24px Calibri",
vertAlign: 1
},
text: "2"
}
]
};
const reaction = {
richText: [
{
style: {
font: "normal 24px Calibri"
},
text: "3 Ba(OH)"
},
{
style: {
font: "normal 24px Calibri",
vertAlign: 2
},
text: "2"
},
{
style: {
font: "normal 24px Calibri"
},
text: " + 2 H"
},
{
style: {
font: "normal 24px Calibri",
vertAlign: 2
},
text: "3"
},
{
style: {
font: "normal 24px Calibri"
},
text: "PO"
},
{
style: {
font: "normal 24px Calibri",
vertAlign: 2
},
text: "4"
},
{
style: {
font: "normal 24px Calibri"
},
text: " → 6 H"
},
{
style: {
font: "normal 24px Calibri",
vertAlign: 2
},
text: "2"
},
{
style: {
font: "normal 24px Calibri"
},
text: "O + Ba"
},
{
style: {
font: "normal 24px Calibri",
vertAlign: 2
},
text: "3"
},
{
style: {
font: "normal 24px Calibri"
},
text: "(PO"
},
{
style: {
font: "normal 24px Calibri",
vertAlign: 2
},
text: "4"
},
{
style: {
font: "normal 24px Calibri"
},
text: ")"
},
{
style: {
font: "normal 24px Calibri",
vertAlign: 2
},
text: "2"
},
{
style: {
font: "normal 24px Calibri"
},
text: "↓"
}
]
};
const google = {
richText: [
{
style: {
font: "bold 36px Calibri",
foreColor: "rgb(78,133,242)"
},
text: "G"
},
{
style: {
font: "bold 36px Calibri",
foreColor: "rgb(228,65,52)"
},
text: "o"
},
{
style: {
font: "bold 36px Calibri",
foreColor: "rgb(247,188,32)"
},
text: "o"
},
{
style: {
font: "bold 36px Calibri",
foreColor: "rgb(78,133,242)"
},
text: "g"
},
{
style: {
font: "bold 36px Calibri",
foreColor: "rgb(65,168,87)"
},
text: "l"
},
{
style: {
font: "bold 36px Calibri",
foreColor: "rgb(228,65,52)"
},
text: "e"
}
]
};
const ingredients = {
richText: [{
type: GC.Spread.Sheets.ListType.disc,
richText: [{
text: "4 beef fillet steaks (about 6 ounces each)"
}]
}, {
type: GC.Spread.Sheets.ListType.disc,
richText: [{
text: "Salt and black pepper, to taste"
}]
}, {
type: GC.Spread.Sheets.ListType.disc,
richText: [{
text: "2 tablespoons olive oil"
}]
}, {
type: GC.Spread.Sheets.ListType.disc,
richText: [{
text: "2 tablespoons Dijon mustard"
}]
}, {
type: GC.Spread.Sheets.ListType.disc,
richText: [{
text: "8 slices of prosciutto or Parma ham"
}]
}, {
type: GC.Spread.Sheets.ListType.disc,
richText: [{
text: "1 package (17.3 ounces) puff pastry, thawed"
}]
}, {
type: GC.Spread.Sheets.ListType.disc,
richText: [{
text: "1 egg, beaten (for egg wash)"
}]
}, {
type: GC.Spread.Sheets.ListType.disc,
richText: [{
text: "Mushroom Duxelles:"
}]
}, {
type: GC.Spread.Sheets.ListType.circle,
level: 1,
richText: [{
text: "2 tablespoons butter"
}]
}, {
type: GC.Spread.Sheets.ListType.circle,
level: 1,
richText: [{
text: "1 shallot, finely chopped"
}]
}, {
type: GC.Spread.Sheets.ListType.circle,
level: 1,
richText: [{
text: "8 ounces mushrooms, finely chopped"
}]
}, {
type: GC.Spread.Sheets.ListType.circle,
level: 1,
richText: [{
text: "2 cloves garlic, minced"
}]
}, {
type: GC.Spread.Sheets.ListType.circle,
level: 1,
richText: [{
text: "2 sprigs fresh thyme, leaves only"
}]
}, {
type: GC.Spread.Sheets.ListType.circle,
level: 1,
richText: [{
text: "Salt and black pepper, to taste"
}]
}]
};
const instructions = {
richText: [{
type: GC.Spread.Sheets.ListType.decimal,
richText: [{
text: "Preheat the oven to 400°F (200°C)."
}]
}, {
type: GC.Spread.Sheets.ListType.decimal,
richText: [{
text: "Season the beef fillet steaks with salt and black pepper on both sides."
}]
}, {
type: GC.Spread.Sheets.ListType.decimal,
richText: [{
text: "Heat olive oil in a skillet over high heat. Sear the steaks for about 1-2 minutes on each side until browned. Remove from heat and let them cool."
}]
}, {
type: GC.Spread.Sheets.ListType.decimal,
richText: [{
text: "Prepare the mushroom duxelles: In the same skillet, melt butter over medium heat. Add the shallot and cook until softened. Add the mushrooms, garlic, and thyme. Cook until the mushrooms release their moisture and it evaporates. Season with salt and black pepper. Remove from heat and let it cool."
}]
}, {
type: GC.Spread.Sheets.ListType.decimal,
richText: [{
text: "On a clean surface, spread out the slices of prosciutto or Parma ham in a slightly overlapping manner to form a rectangle large enough to wrap each steak."
}]
}, {
type: GC.Spread.Sheets.ListType.decimal,
richText: [{
text: "Spread a thin layer of Dijon mustard over the cooled steaks. Place each steak on top of a prosciutto rectangle."
}]
}, {
type: GC.Spread.Sheets.ListType.decimal,
richText: [{
text: "Spoon the mushroom duxelles evenly over each steak."
}]
}, {
type: GC.Spread.Sheets.ListType.decimal,
richText: [{
text: "Carefully wrap the prosciutto and mushroom-covered steaks with the puff pastry, ensuring the seams are sealed. Trim off any excess pastry."
}]
}, {
type: GC.Spread.Sheets.ListType.decimal,
richText: [{
text: "Place the wrapped steaks on a baking sheet lined with parchment paper. Brush the puff pastry with beaten egg to create a golden crust."
}]
}, {
type: GC.Spread.Sheets.ListType.decimal,
richText: [{
text: "Bake in the preheated oven for about 20-25 minutes, or until the puff pastry is golden brown and the steak is cooked to your desired doneness. For medium-rare, the internal temperature should be around 130-135°F (55-57°C)."
}]
}, {
type: GC.Spread.Sheets.ListType.decimal,
richText: [{
text: "Remove from the oven and let the Steak Wellington rest for a few minutes before serving."
}]
}, {
type: GC.Spread.Sheets.ListType.decimal,
richText: [{
text: "Serve the Steak Wellington sliced, and enjoy it with your favorite sides like roasted potatoes, steamed vegetables, or a green salad."
}]
}]
};
spread.suspendPaint();
const sheet = spread.sheets[0];
sheet.setColumnWidth(0, 720);
sheet.setValue(0, 0, 'Law of universal gravitation:', 3);
sheet.setValue(1, 0, lawOfUniversalGravitation, 3);
sheet.setRowHeight(1, 40);
sheet.getCell(1, 0).vAlign(spreadNS.VerticalAlign.center);
sheet.setValue(3, 0, 'The reaction of barium hydroxide with phosphoric acid:', 3);
sheet.setValue(4, 0, reaction, 3);
sheet.setRowHeight(4, 40);
sheet.getCell(4, 0).vAlign(spreadNS.VerticalAlign.center);
sheet.setValue(6, 0, google, 3);
sheet.setRowHeight(6, 50);
sheet.name('Basic Usage');
const listSheet = new GC.Spread.Sheets.Worksheet('List Usage');
spread.addSheet(1, listSheet);
spread.setActiveSheet('List Usage');
listSheet.setColumnWidth(0, 720);
listSheet.setValue(0, 0, 'Steak Wellington Ingredients');
listSheet.setValue(1, 0, ingredients);
listSheet.getCell(1, 0).wordWrap(true);
listSheet.autoFitRow(1);
listSheet.setValue(3, 0, 'Steak Wellington Instructions');
listSheet.setValue(4, 0, instructions);
listSheet.getCell(4, 0).wordWrap(true);
listSheet.autoFitRow(4);
spread.resumePaint();
spread.options.tabStripRatio = 0.8;
}
const initDesigner = (designer) => {
spreadRef.value = designer.getWorkbook();
initSpread(spreadRef.value);
}
</script>
<style scoped>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
#app {
height: 100%;
}
.description {
margin: 10px;
width: 40%;
}
table {
font-family: arial, sans-serif;
border-collapse: collapse;
width: 100%;
}
</style>
<!DOCTYPE html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<title>SpreadJS VUE</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/vue3/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/vue3/node_modules/@mescius/spread-sheets-designer/styles/gc.spread.sheets.designer.light.min.css">
<script src="$DEMOROOT$/en/vue3/node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script src="compiler.js" type="module"></script>
<script>
var System = SystemJS;
System.import("./src/app.js");
System.import('$DEMOROOT$/en/lib/vue3/license.js');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
(function (global) {
SystemJS.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
packageConfigPaths: [
'./node_modules/*/package.json',
"./node_modules/@mescius/*/package.json",
"./node_modules/@babel/*/package.json",
"./node_modules/@vue/*/package.json"
],
map: {
'vue': "npm:vue/dist/vue.esm-browser.js",
'tiny-emitter': 'npm:tiny-emitter/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
"systemjs-babel-build": "npm:systemjs-plugin-babel/systemjs-babel-browser.js",
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-vue': 'npm:@mescius/spread-sheets-vue/index.js',
'@mescius/spread-sheets-barcode': 'npm:@mescius/spread-sheets-barcode/index.js',
'@mescius/spread-sheets-charts': 'npm:@mescius/spread-sheets-charts/index.js',
'@mescius/spread-sheets-languagepackages': 'npm:@mescius/spread-sheets-languagepackages/index.js',
'@mescius/spread-sheets-print': 'npm:@mescius/spread-sheets-print/index.js',
'@mescius/spread-sheets-pdf': 'npm:@mescius/spread-sheets-pdf/index.js',
'@mescius/spread-sheets-shapes': 'npm:@mescius/spread-sheets-shapes/index.js',
'@mescius/spread-sheets-slicers': 'npm:@mescius/spread-sheets-slicers/index.js',
'@mescius/spread-sheets-formula-panel': 'npm:@mescius/spread-sheets-formula-panel/index.js',
'@mescius/spread-sheets-io': 'npm:@mescius/spread-sheets-io/index.js',
'@mescius/spread-sheets-designer': 'npm:@mescius/spread-sheets-designer/index.js',
'@mescius/spread-sheets-designer-vue': 'npm:@mescius/spread-sheets-designer-vue/index.js',
'@mescius/spread-sheets-pivot-addon': 'npm:@mescius/spread-sheets-pivot-addon/index.js',
'@mescius/spread-sheets-tablesheet': 'npm:@mescius/spread-sheets-tablesheet/index.js',
'@mescius/spread-sheets-designer-resources-en': 'npm:@mescius/spread-sheets-designer-resources-en/index.js',
},
meta: {
'*.css': { loader: 'systemjs-plugin-css' },
'*.vue': { loader: "../plugin-vue/index.js" }
}
});
})(this);

Rich text data is an anonymous object, you should follow the JSON Schema.
You can set the value for the specified cell in the specified sheet area using the following code:
You can get the unformatted data from the specified cell in the specified sheet area using the following code:
Updated: Rich text now support list
import * as React from 'react';
import { createRoot } from 'react-dom/client';
import './styles.css';
import { AppFunc } from './app-func';
import { App } from './app-class';
// 1. Functional Component sample
createRoot(document.getElementById('app')).render(<AppFunc />);
// 2. Class Component sample
// createRoot(document.getElementById('app')).render(<App />);
import * as React from "react";
import GC from "@mescius/spread-sheets";
import "@mescius/spread-sheets-pivot-addon";
import "@mescius/spread-sheets-tablesheet";
import "@mescius/spread-sheets-io";
import "@mescius/spread-sheets-designer-resources-en";
GC.Spread.Common.CultureManager.culture("en-us");
import { Designer } from "@mescius/spread-sheets-designer-react";
import {registerlic} from '$DEMOROOT$/spread/source/js/designer/react_vue/license.js'
registerlic(GC);
const spreadNS = GC.Spread.Sheets;
const richEditorHelper = {
toHexColor (color) {
let reg = /^#([0-9a-fA-F]{3}|[0-9a-fA-F]{6})$/;
if (/^(rgb|RGB)/.test(color)) {
let aColor = color.replace(/(?:\(|\)|rgb|RGB)*/g, "").split(",");
let strHex = "#";
for (let i = 0; i < aColor.length; i++) {
let hex = Number(aColor[i]).toString(16);
if (hex.length < 2) {
hex = '0' + hex;
}
strHex += hex;
}
if (strHex.length !== 7) {
strHex = color;
}
return strHex;
} else if (reg.test(color)) {
let aNum = color.replace(/#/, "").split("");
if (aNum.length === 6) {
return color;
} else if (aNum.length === 3) {
let numHex = "#";
for (let i = 0; i < aNum.length; i += 1) {
numHex += (aNum[i] + aNum[i]);
}
return numHex;
}
}
return color;
},
getStandardFont (unStandardFont) {
if (!unStandardFont) {
return;
}
let style = new spreadNS.Style();
style.font = unStandardFont;
let { fontWeight, fontSize } = style;
if (!isNaN(fontWeight)) {
style.fontWeight = +fontWeight >= 700 ? "bold" : "normal";
}
style.fontSize = (fontSize.indexOf("px") > 0) ? (Math.round((+(fontSize.split("px")[0])) * 3 / 4) + "pt") : fontSize;
return style.font;
},
setDefaultStyleToRichItem (richText, font, foreColor, textDecoration) {
richText.style = {
font,
foreColor,
textDecoration
};
},
isNullOrUndefined (value) {
return value === undefined || value === null;
},
composeCurrentRichItemStyleWithActiveCellStyle (richText, cellStyle, theme) {
const currentItemStyle = richText.style;
if (currentItemStyle.foreColor === undefined && !richEditorHelper.isNullOrUndefined(cellStyle.foreColor)) {
currentItemStyle.foreColor = cellStyle.foreColor;
}
if (currentItemStyle.font === undefined && !richEditorHelper.isNullOrUndefined(cellStyle.font)) {
currentItemStyle.font = cellStyle.font;
} else if (currentItemStyle.font) {
currentItemStyle.font = richEditorHelper.getStandardFont(currentItemStyle.font);
}
if (currentItemStyle.textDecoration === undefined && !richEditorHelper.isNullOrUndefined(cellStyle.textDecoration)) {
currentItemStyle.textDecoration = cellStyle.textDecoration;
}
currentItemStyle.foreColor = richEditorHelper.toHexColor(theme.getColor(currentItemStyle.foreColor));
},
splitRichTextByLineBreaker (richText, newRichTexts) {
const currentItemStyle = richText.style;
const wrappedTexts = richText.text.split(/\r?\n/g);
for (let j = 0, wrapperLen = wrappedTexts.length; j < wrapperLen; j++) {
let obj = {};
obj.text = wrappedTexts[j];
obj.style = currentItemStyle;
if (obj.text) {
newRichTexts.push(obj);
}
if (j !== wrapperLen - 1) {
newRichTexts.push({
text: '\r\n',
style: currentItemStyle
});
}
}
},
createRichTextsFromPlainText (sheet, row, col, font, foreColor, textDecoration) {
const text = sheet.getText(row, col);
const wrappedTexts = text.split("\n");
const richTexts = [];
for (let i = 0, len = wrappedTexts.length; i < len; i++) {
if (wrappedTexts[i]) {
richTexts.push({
text: wrappedTexts[i],
style: {
font,
foreColor,
textDecoration
}
});
}
if (i !== len - 1) {
richTexts.push({
text: '\r\n',
style: richTexts[i].style
});
}
}
return richTexts;
},
getRichStyleFromCellStyle (cellStyle, theme) {
return {
font: cellStyle.font,
textDecoration: cellStyle.textDecoration,
foreColor: cellStyle.foreColor
}
},
getRichTextItemsForRichEditor (sheet, row, col) {
const value = sheet.getValue(row, col, spreadNS.SheetArea.viewport, spreadNS.ValueType.richText);
const cellStyle = sheet.getActualStyle(row, col);
const theme = sheet.currentTheme();
if (cellStyle.foreColor && theme) {
cellStyle.foreColor = richEditorHelper.toHexColor(theme.getColor(cellStyle.foreColor));
}
if (!value) {
return [{
text: "",
style: richEditorHelper.getRichStyleFromCellStyle(cellStyle)
}];
}
let richTexts = value.richText;
let foreColor = cellStyle.foreColor || "#000000";
let textDecoration = cellStyle.textDecoration;
let font = cellStyle.font ? richEditorHelper.getStandardFont(cellStyle.font) : "11pt Calibri";
if (richTexts) {
let newRichTexts = [];
for (let i = 0, len = richTexts.length; i < len; i++) {
if (!richTexts[i]) {
continue;
}
if (!richTexts[i].style) {
richEditorHelper.setDefaultStyleToRichItem(richTexts[i], font, foreColor, textDecoration);
} else if (richTexts[i].style) {
richEditorHelper.composeCurrentRichItemStyleWithActiveCellStyle(richTexts[i], cellStyle, theme);
}
if (richTexts[i].text && richTexts[i].text !== "\r\n" && richTexts[i].text !== '\n' && richTexts[i].text.split(/\r?\n/g).length > 1) {
richEditorHelper.splitRichTextByLineBreaker(richTexts[i], newRichTexts);
} else {
newRichTexts.push(richTexts[i]);
}
}
return newRichTexts;
} else {
return richEditorHelper.createRichTextsFromPlainText(sheet, row, col, font, foreColor, textDecoration);
}
}
};
const getDesignerConfig = () => {
GC.Spread.Sheets.Designer.registerTemplate("richEditor", {
content: [{
type: "RichTextEditor",
bindingPath: "value",
editorWidth: "640px",
editorHeight: "542px",
onChange: (value, spread) => {
if (!spread || !value) {
return;
}
let sheet = spread.getActiveSheet();
sheet.setValue(sheet.getActiveRowIndex(), sheet.getActiveColumnIndex(), value.value);
}
}]
});
const richEditorPanel = {
position: "right",
width: "640px",
command: "richEditor",
uiTemplate: "richEditor"
};
let oldSheetName, oldRow, oldCol, oldValue;
const richEditorCommand = {
commandName: 'richEditor',
getState: (context) => {
const spread = context.getWorkbook(), activeSheet = spread.getActiveSheet(), activeRow = activeSheet.getActiveRowIndex(), activeCol = activeSheet.getActiveColumnIndex();
// only when change active cell, need to reset editor content
if (oldSheetName === activeSheet.name() && oldRow === activeRow && oldCol === activeCol) {
return oldValue;
}
oldSheetName = activeSheet.name();
oldRow = activeRow;
oldCol = activeCol;
const richTextItems = richEditorHelper.getRichTextItemsForRichEditor(activeSheet, activeRow, activeCol);
oldValue = {
value: {
value: {
richText: richTextItems
},
style: activeSheet.getActualStyle(activeRow, activeCol)
}
};
return oldValue;
}
}
return {
contextMenu: [],
ribbon: [],
sidePanels: [richEditorPanel],
commandMap: {
richEditor: richEditorCommand
}
};
};
const initSpread = (spread) => {
const lawOfUniversalGravitation = {
richText: [
{
style: {
font: "normal 24px Calibri"
},
text: "F = (G * M"
},
{
style: {
font: "normal 24px Calibri",
vertAlign: 2
},
text: "1"
},
{
style: {
font: "normal 24px Calibri"
},
text: " * M"
},
{
style: {
font: "normal 24px Calibri",
vertAlign: 2
},
text: "2"
},
{
style: {
font: "normal 24px Calibri"
},
text: ") / R"
},
{
style: {
font: "normal 24px Calibri",
vertAlign: 1
},
text: "2"
}
]
};
const reaction = {
richText: [
{
style: {
font: "normal 24px Calibri"
},
text: "3 Ba(OH)"
},
{
style: {
font: "normal 24px Calibri",
vertAlign: 2
},
text: "2"
},
{
style: {
font: "normal 24px Calibri"
},
text: " + 2 H"
},
{
style: {
font: "normal 24px Calibri",
vertAlign: 2
},
text: "3"
},
{
style: {
font: "normal 24px Calibri"
},
text: "PO"
},
{
style: {
font: "normal 24px Calibri",
vertAlign: 2
},
text: "4"
},
{
style: {
font: "normal 24px Calibri"
},
text: " → 6 H"
},
{
style: {
font: "normal 24px Calibri",
vertAlign: 2
},
text: "2"
},
{
style: {
font: "normal 24px Calibri"
},
text: "O + Ba"
},
{
style: {
font: "normal 24px Calibri",
vertAlign: 2
},
text: "3"
},
{
style: {
font: "normal 24px Calibri"
},
text: "(PO"
},
{
style: {
font: "normal 24px Calibri",
vertAlign: 2
},
text: "4"
},
{
style: {
font: "normal 24px Calibri"
},
text: ")"
},
{
style: {
font: "normal 24px Calibri",
vertAlign: 2
},
text: "2"
},
{
style: {
font: "normal 24px Calibri"
},
text: "↓"
}
]
};
const google = {
richText: [
{
style: {
font: "bold 36px Calibri",
foreColor: "rgb(78,133,242)"
},
text: "G"
},
{
style: {
font: "bold 36px Calibri",
foreColor: "rgb(228,65,52)"
},
text: "o"
},
{
style: {
font: "bold 36px Calibri",
foreColor: "rgb(247,188,32)"
},
text: "o"
},
{
style: {
font: "bold 36px Calibri",
foreColor: "rgb(78,133,242)"
},
text: "g"
},
{
style: {
font: "bold 36px Calibri",
foreColor: "rgb(65,168,87)"
},
text: "l"
},
{
style: {
font: "bold 36px Calibri",
foreColor: "rgb(228,65,52)"
},
text: "e"
}
]
};
const ingredients = {
richText: [{
type: GC.Spread.Sheets.ListType.disc,
richText: [{
text: "4 beef fillet steaks (about 6 ounces each)"
}]
}, {
type: GC.Spread.Sheets.ListType.disc,
richText: [{
text: "Salt and black pepper, to taste"
}]
}, {
type: GC.Spread.Sheets.ListType.disc,
richText: [{
text: "2 tablespoons olive oil"
}]
}, {
type: GC.Spread.Sheets.ListType.disc,
richText: [{
text: "2 tablespoons Dijon mustard"
}]
}, {
type: GC.Spread.Sheets.ListType.disc,
richText: [{
text: "8 slices of prosciutto or Parma ham"
}]
}, {
type: GC.Spread.Sheets.ListType.disc,
richText: [{
text: "1 package (17.3 ounces) puff pastry, thawed"
}]
}, {
type: GC.Spread.Sheets.ListType.disc,
richText: [{
text: "1 egg, beaten (for egg wash)"
}]
}, {
type: GC.Spread.Sheets.ListType.disc,
richText: [{
text: "Mushroom Duxelles:"
}]
}, {
type: GC.Spread.Sheets.ListType.circle,
level: 1,
richText: [{
text: "2 tablespoons butter"
}]
}, {
type: GC.Spread.Sheets.ListType.circle,
level: 1,
richText: [{
text: "1 shallot, finely chopped"
}]
}, {
type: GC.Spread.Sheets.ListType.circle,
level: 1,
richText: [{
text: "8 ounces mushrooms, finely chopped"
}]
}, {
type: GC.Spread.Sheets.ListType.circle,
level: 1,
richText: [{
text: "2 cloves garlic, minced"
}]
}, {
type: GC.Spread.Sheets.ListType.circle,
level: 1,
richText: [{
text: "2 sprigs fresh thyme, leaves only"
}]
}, {
type: GC.Spread.Sheets.ListType.circle,
level: 1,
richText: [{
text: "Salt and black pepper, to taste"
}]
}]
};
const instructions = {
richText: [{
type: GC.Spread.Sheets.ListType.decimal,
richText: [{
text: "Preheat the oven to 400°F (200°C)."
}]
}, {
type: GC.Spread.Sheets.ListType.decimal,
richText: [{
text: "Season the beef fillet steaks with salt and black pepper on both sides."
}]
}, {
type: GC.Spread.Sheets.ListType.decimal,
richText: [{
text: "Heat olive oil in a skillet over high heat. Sear the steaks for about 1-2 minutes on each side until browned. Remove from heat and let them cool."
}]
}, {
type: GC.Spread.Sheets.ListType.decimal,
richText: [{
text: "Prepare the mushroom duxelles: In the same skillet, melt butter over medium heat. Add the shallot and cook until softened. Add the mushrooms, garlic, and thyme. Cook until the mushrooms release their moisture and it evaporates. Season with salt and black pepper. Remove from heat and let it cool."
}]
}, {
type: GC.Spread.Sheets.ListType.decimal,
richText: [{
text: "On a clean surface, spread out the slices of prosciutto or Parma ham in a slightly overlapping manner to form a rectangle large enough to wrap each steak."
}]
}, {
type: GC.Spread.Sheets.ListType.decimal,
richText: [{
text: "Spread a thin layer of Dijon mustard over the cooled steaks. Place each steak on top of a prosciutto rectangle."
}]
}, {
type: GC.Spread.Sheets.ListType.decimal,
richText: [{
text: "Spoon the mushroom duxelles evenly over each steak."
}]
}, {
type: GC.Spread.Sheets.ListType.decimal,
richText: [{
text: "Carefully wrap the prosciutto and mushroom-covered steaks with the puff pastry, ensuring the seams are sealed. Trim off any excess pastry."
}]
}, {
type: GC.Spread.Sheets.ListType.decimal,
richText: [{
text: "Place the wrapped steaks on a baking sheet lined with parchment paper. Brush the puff pastry with beaten egg to create a golden crust."
}]
}, {
type: GC.Spread.Sheets.ListType.decimal,
richText: [{
text: "Bake in the preheated oven for about 20-25 minutes, or until the puff pastry is golden brown and the steak is cooked to your desired doneness. For medium-rare, the internal temperature should be around 130-135°F (55-57°C)."
}]
}, {
type: GC.Spread.Sheets.ListType.decimal,
richText: [{
text: "Remove from the oven and let the Steak Wellington rest for a few minutes before serving."
}]
}, {
type: GC.Spread.Sheets.ListType.decimal,
richText: [{
text: "Serve the Steak Wellington sliced, and enjoy it with your favorite sides like roasted potatoes, steamed vegetables, or a green salad."
}]
}]
};
spread.suspendPaint();
const sheet = spread.sheets[0];
sheet.setColumnWidth(0, 720);
sheet.setValue(0, 0, 'Law of universal gravitation:', 3);
sheet.setValue(1, 0, lawOfUniversalGravitation, 3);
sheet.setRowHeight(1, 40);
sheet.getCell(1, 0).vAlign(spreadNS.VerticalAlign.center);
sheet.setValue(3, 0, 'The reaction of barium hydroxide with phosphoric acid:', 3);
sheet.setValue(4, 0, reaction, 3);
sheet.setRowHeight(4, 40);
sheet.getCell(4, 0).vAlign(spreadNS.VerticalAlign.center);
sheet.setValue(6, 0, google, 3);
sheet.setRowHeight(6, 50);
sheet.name('Basic Usage');
const listSheet = new GC.Spread.Sheets.Worksheet('List Usage');
spread.addSheet(1, listSheet);
spread.setActiveSheet('List Usage');
listSheet.setColumnWidth(0, 720);
listSheet.setValue(0, 0, 'Steak Wellington Ingredients');
listSheet.setValue(1, 0, ingredients);
listSheet.getCell(1, 0).wordWrap(true);
listSheet.autoFitRow(1);
listSheet.setValue(3, 0, 'Steak Wellington Instructions');
listSheet.setValue(4, 0, instructions);
listSheet.getCell(4, 0).wordWrap(true);
listSheet.autoFitRow(4);
spread.resumePaint();
spread.options.tabStripRatio = 0.8;
}
export function AppFunc() {
let config = getDesignerConfig();
const initDesigner = (designer) => {
let workbook = designer.getWorkbook();
initSpread(workbook);
};
return (
<div class="sample-tutorial">
<Designer
styleInfo={{ height: "100%" }}
config={config}
designerInitialized={(designer) => initDesigner(designer)}
></Designer>
</div>
);
}
import * as React from "react";
import GC from "@mescius/spread-sheets";
import "@mescius/spread-sheets-pivot-addon";
import "@mescius/spread-sheets-tablesheet";
import "@mescius/spread-sheets-io";
import "@mescius/spread-sheets-designer-resources-en";
GC.Spread.Common.CultureManager.culture("en-us");
import { Designer } from "@mescius/spread-sheets-designer-react";
import {registerlic} from '$DEMOROOT$/spread/source/js/designer/react_vue/license.js'
registerlic(GC);
const spreadNS = GC.Spread.Sheets;
const richEditorHelper = {
toHexColor (color) {
let reg = /^#([0-9a-fA-F]{3}|[0-9a-fA-F]{6})$/;
if (/^(rgb|RGB)/.test(color)) {
let aColor = color.replace(/(?:\(|\)|rgb|RGB)*/g, "").split(",");
let strHex = "#";
for (let i = 0; i < aColor.length; i++) {
let hex = Number(aColor[i]).toString(16);
if (hex.length < 2) {
hex = '0' + hex;
}
strHex += hex;
}
if (strHex.length !== 7) {
strHex = color;
}
return strHex;
} else if (reg.test(color)) {
let aNum = color.replace(/#/, "").split("");
if (aNum.length === 6) {
return color;
} else if (aNum.length === 3) {
let numHex = "#";
for (let i = 0; i < aNum.length; i += 1) {
numHex += (aNum[i] + aNum[i]);
}
return numHex;
}
}
return color;
},
getStandardFont (unStandardFont) {
if (!unStandardFont) {
return;
}
let style = new spreadNS.Style();
style.font = unStandardFont;
let { fontWeight, fontSize } = style;
if (!isNaN(fontWeight)) {
style.fontWeight = +fontWeight >= 700 ? "bold" : "normal";
}
style.fontSize = (fontSize.indexOf("px") > 0) ? (Math.round((+(fontSize.split("px")[0])) * 3 / 4) + "pt") : fontSize;
return style.font;
},
setDefaultStyleToRichItem (richText, font, foreColor, textDecoration) {
richText.style = {
font,
foreColor,
textDecoration
};
},
isNullOrUndefined (value) {
return value === undefined || value === null;
},
composeCurrentRichItemStyleWithActiveCellStyle (richText, cellStyle, theme) {
const currentItemStyle = richText.style;
if (currentItemStyle.foreColor === undefined && !richEditorHelper.isNullOrUndefined(cellStyle.foreColor)) {
currentItemStyle.foreColor = cellStyle.foreColor;
}
if (currentItemStyle.font === undefined && !richEditorHelper.isNullOrUndefined(cellStyle.font)) {
currentItemStyle.font = cellStyle.font;
} else if (currentItemStyle.font) {
currentItemStyle.font = richEditorHelper.getStandardFont(currentItemStyle.font);
}
if (currentItemStyle.textDecoration === undefined && !richEditorHelper.isNullOrUndefined(cellStyle.textDecoration)) {
currentItemStyle.textDecoration = cellStyle.textDecoration;
}
currentItemStyle.foreColor = richEditorHelper.toHexColor(theme.getColor(currentItemStyle.foreColor));
},
splitRichTextByLineBreaker (richText, newRichTexts) {
const currentItemStyle = richText.style;
const wrappedTexts = richText.text.split(/\r?\n/g);
for (let j = 0, wrapperLen = wrappedTexts.length; j < wrapperLen; j++) {
let obj = {};
obj.text = wrappedTexts[j];
obj.style = currentItemStyle;
if (obj.text) {
newRichTexts.push(obj);
}
if (j !== wrapperLen - 1) {
newRichTexts.push({
text: '\r\n',
style: currentItemStyle
});
}
}
},
createRichTextsFromPlainText (sheet, row, col, font, foreColor, textDecoration) {
const text = sheet.getText(row, col);
const wrappedTexts = text.split("\n");
const richTexts = [];
for (let i = 0, len = wrappedTexts.length; i < len; i++) {
if (wrappedTexts[i]) {
richTexts.push({
text: wrappedTexts[i],
style: {
font,
foreColor,
textDecoration
}
});
}
if (i !== len - 1) {
richTexts.push({
text: '\r\n',
style: richTexts[i].style
});
}
}
return richTexts;
},
getRichStyleFromCellStyle (cellStyle, theme) {
return {
font: cellStyle.font,
textDecoration: cellStyle.textDecoration,
foreColor: cellStyle.foreColor
}
},
getRichTextItemsForRichEditor (sheet, row, col) {
const value = sheet.getValue(row, col, spreadNS.SheetArea.viewport, spreadNS.ValueType.richText);
const cellStyle = sheet.getActualStyle(row, col);
const theme = sheet.currentTheme();
if (cellStyle.foreColor && theme) {
cellStyle.foreColor = richEditorHelper.toHexColor(theme.getColor(cellStyle.foreColor));
}
if (!value) {
return [{
text: "",
style: richEditorHelper.getRichStyleFromCellStyle(cellStyle)
}];
}
let richTexts = value.richText;
let foreColor = cellStyle.foreColor || "#000000";
let textDecoration = cellStyle.textDecoration;
let font = cellStyle.font ? richEditorHelper.getStandardFont(cellStyle.font) : "11pt Calibri";
if (richTexts) {
let newRichTexts = [];
for (let i = 0, len = richTexts.length; i < len; i++) {
if (!richTexts[i]) {
continue;
}
if (!richTexts[i].style) {
richEditorHelper.setDefaultStyleToRichItem(richTexts[i], font, foreColor, textDecoration);
} else if (richTexts[i].style) {
richEditorHelper.composeCurrentRichItemStyleWithActiveCellStyle(richTexts[i], cellStyle, theme);
}
if (richTexts[i].text && richTexts[i].text !== "\r\n" && richTexts[i].text !== '\n' && richTexts[i].text.split(/\r?\n/g).length > 1) {
richEditorHelper.splitRichTextByLineBreaker(richTexts[i], newRichTexts);
} else {
newRichTexts.push(richTexts[i]);
}
}
return newRichTexts;
} else {
return richEditorHelper.createRichTextsFromPlainText(sheet, row, col, font, foreColor, textDecoration);
}
}
};
export class App extends React.Component {
constructor(props) {
super(props);
this.spread = null;
this.config = this.getDesignerConfig();
}
initDesigner(designer) {
let workbook = designer.getWorkbook();
this.spread = workbook;
this.initSpread(workbook);
}
render() {
return (
<div class="sample-tutorial">
<Designer
styleInfo={{ height: "100%" }}
config={this.config}
designerInitialized={(designer) => this.initDesigner(designer)}
></Designer>
</div>
);
}
getDesignerConfig() {
GC.Spread.Sheets.Designer.registerTemplate("richEditor", {
content: [{
type: "RichTextEditor",
bindingPath: "value",
editorWidth: "640px",
editorHeight: "542px",
onChange: (value, spread) => {
if (!spread || !value) {
return;
}
let sheet = spread.getActiveSheet();
sheet.setValue(sheet.getActiveRowIndex(), sheet.getActiveColumnIndex(), value.value);
}
}]
});
const richEditorPanel = {
position: "right",
width: "640px",
command: "richEditor",
uiTemplate: "richEditor"
};
let oldSheetName, oldRow, oldCol, oldValue;
const richEditorCommand = {
commandName: 'richEditor',
getState: (context) => {
const spread = context.getWorkbook(), activeSheet = spread.getActiveSheet(), activeRow = activeSheet.getActiveRowIndex(), activeCol = activeSheet.getActiveColumnIndex();
// only when change active cell, need to reset editor content
if (oldSheetName === activeSheet.name() && oldRow === activeRow && oldCol === activeCol) {
return oldValue;
}
oldSheetName = activeSheet.name();
oldRow = activeRow;
oldCol = activeCol;
const richTextItems = richEditorHelper.getRichTextItemsForRichEditor(activeSheet, activeRow, activeCol);
oldValue = {
value: {
value: {
richText: richTextItems
},
style: activeSheet.getActualStyle(activeRow, activeCol)
}
};
return oldValue;
}
}
return {
contextMenu: [],
ribbon: [],
sidePanels: [richEditorPanel],
commandMap: {
richEditor: richEditorCommand
}
};
}
initSpread(spread) {
const lawOfUniversalGravitation = {
richText: [
{
style: {
font: "normal 24px Calibri"
},
text: "F = (G * M"
},
{
style: {
font: "normal 24px Calibri",
vertAlign: 2
},
text: "1"
},
{
style: {
font: "normal 24px Calibri"
},
text: " * M"
},
{
style: {
font: "normal 24px Calibri",
vertAlign: 2
},
text: "2"
},
{
style: {
font: "normal 24px Calibri"
},
text: ") / R"
},
{
style: {
font: "normal 24px Calibri",
vertAlign: 1
},
text: "2"
}
]
};
const reaction = {
richText: [
{
style: {
font: "normal 24px Calibri"
},
text: "3 Ba(OH)"
},
{
style: {
font: "normal 24px Calibri",
vertAlign: 2
},
text: "2"
},
{
style: {
font: "normal 24px Calibri"
},
text: " + 2 H"
},
{
style: {
font: "normal 24px Calibri",
vertAlign: 2
},
text: "3"
},
{
style: {
font: "normal 24px Calibri"
},
text: "PO"
},
{
style: {
font: "normal 24px Calibri",
vertAlign: 2
},
text: "4"
},
{
style: {
font: "normal 24px Calibri"
},
text: " → 6 H"
},
{
style: {
font: "normal 24px Calibri",
vertAlign: 2
},
text: "2"
},
{
style: {
font: "normal 24px Calibri"
},
text: "O + Ba"
},
{
style: {
font: "normal 24px Calibri",
vertAlign: 2
},
text: "3"
},
{
style: {
font: "normal 24px Calibri"
},
text: "(PO"
},
{
style: {
font: "normal 24px Calibri",
vertAlign: 2
},
text: "4"
},
{
style: {
font: "normal 24px Calibri"
},
text: ")"
},
{
style: {
font: "normal 24px Calibri",
vertAlign: 2
},
text: "2"
},
{
style: {
font: "normal 24px Calibri"
},
text: "↓"
}
]
};
const google = {
richText: [
{
style: {
font: "bold 36px Calibri",
foreColor: "rgb(78,133,242)"
},
text: "G"
},
{
style: {
font: "bold 36px Calibri",
foreColor: "rgb(228,65,52)"
},
text: "o"
},
{
style: {
font: "bold 36px Calibri",
foreColor: "rgb(247,188,32)"
},
text: "o"
},
{
style: {
font: "bold 36px Calibri",
foreColor: "rgb(78,133,242)"
},
text: "g"
},
{
style: {
font: "bold 36px Calibri",
foreColor: "rgb(65,168,87)"
},
text: "l"
},
{
style: {
font: "bold 36px Calibri",
foreColor: "rgb(228,65,52)"
},
text: "e"
}
]
};
const ingredients = {
richText: [{
type: GC.Spread.Sheets.ListType.disc,
richText: [{
text: "4 beef fillet steaks (about 6 ounces each)"
}]
}, {
type: GC.Spread.Sheets.ListType.disc,
richText: [{
text: "Salt and black pepper, to taste"
}]
}, {
type: GC.Spread.Sheets.ListType.disc,
richText: [{
text: "2 tablespoons olive oil"
}]
}, {
type: GC.Spread.Sheets.ListType.disc,
richText: [{
text: "2 tablespoons Dijon mustard"
}]
}, {
type: GC.Spread.Sheets.ListType.disc,
richText: [{
text: "8 slices of prosciutto or Parma ham"
}]
}, {
type: GC.Spread.Sheets.ListType.disc,
richText: [{
text: "1 package (17.3 ounces) puff pastry, thawed"
}]
}, {
type: GC.Spread.Sheets.ListType.disc,
richText: [{
text: "1 egg, beaten (for egg wash)"
}]
}, {
type: GC.Spread.Sheets.ListType.disc,
richText: [{
text: "Mushroom Duxelles:"
}]
}, {
type: GC.Spread.Sheets.ListType.circle,
level: 1,
richText: [{
text: "2 tablespoons butter"
}]
}, {
type: GC.Spread.Sheets.ListType.circle,
level: 1,
richText: [{
text: "1 shallot, finely chopped"
}]
}, {
type: GC.Spread.Sheets.ListType.circle,
level: 1,
richText: [{
text: "8 ounces mushrooms, finely chopped"
}]
}, {
type: GC.Spread.Sheets.ListType.circle,
level: 1,
richText: [{
text: "2 cloves garlic, minced"
}]
}, {
type: GC.Spread.Sheets.ListType.circle,
level: 1,
richText: [{
text: "2 sprigs fresh thyme, leaves only"
}]
}, {
type: GC.Spread.Sheets.ListType.circle,
level: 1,
richText: [{
text: "Salt and black pepper, to taste"
}]
}]
};
const instructions = {
richText: [{
type: GC.Spread.Sheets.ListType.decimal,
richText: [{
text: "Preheat the oven to 400°F (200°C)."
}]
}, {
type: GC.Spread.Sheets.ListType.decimal,
richText: [{
text: "Season the beef fillet steaks with salt and black pepper on both sides."
}]
}, {
type: GC.Spread.Sheets.ListType.decimal,
richText: [{
text: "Heat olive oil in a skillet over high heat. Sear the steaks for about 1-2 minutes on each side until browned. Remove from heat and let them cool."
}]
}, {
type: GC.Spread.Sheets.ListType.decimal,
richText: [{
text: "Prepare the mushroom duxelles: In the same skillet, melt butter over medium heat. Add the shallot and cook until softened. Add the mushrooms, garlic, and thyme. Cook until the mushrooms release their moisture and it evaporates. Season with salt and black pepper. Remove from heat and let it cool."
}]
}, {
type: GC.Spread.Sheets.ListType.decimal,
richText: [{
text: "On a clean surface, spread out the slices of prosciutto or Parma ham in a slightly overlapping manner to form a rectangle large enough to wrap each steak."
}]
}, {
type: GC.Spread.Sheets.ListType.decimal,
richText: [{
text: "Spread a thin layer of Dijon mustard over the cooled steaks. Place each steak on top of a prosciutto rectangle."
}]
}, {
type: GC.Spread.Sheets.ListType.decimal,
richText: [{
text: "Spoon the mushroom duxelles evenly over each steak."
}]
}, {
type: GC.Spread.Sheets.ListType.decimal,
richText: [{
text: "Carefully wrap the prosciutto and mushroom-covered steaks with the puff pastry, ensuring the seams are sealed. Trim off any excess pastry."
}]
}, {
type: GC.Spread.Sheets.ListType.decimal,
richText: [{
text: "Place the wrapped steaks on a baking sheet lined with parchment paper. Brush the puff pastry with beaten egg to create a golden crust."
}]
}, {
type: GC.Spread.Sheets.ListType.decimal,
richText: [{
text: "Bake in the preheated oven for about 20-25 minutes, or until the puff pastry is golden brown and the steak is cooked to your desired doneness. For medium-rare, the internal temperature should be around 130-135°F (55-57°C)."
}]
}, {
type: GC.Spread.Sheets.ListType.decimal,
richText: [{
text: "Remove from the oven and let the Steak Wellington rest for a few minutes before serving."
}]
}, {
type: GC.Spread.Sheets.ListType.decimal,
richText: [{
text: "Serve the Steak Wellington sliced, and enjoy it with your favorite sides like roasted potatoes, steamed vegetables, or a green salad."
}]
}]
};
spread.suspendPaint();
const sheet = spread.sheets[0];
sheet.setColumnWidth(0, 720);
sheet.setValue(0, 0, 'Law of universal gravitation:', 3);
sheet.setValue(1, 0, lawOfUniversalGravitation, 3);
sheet.setRowHeight(1, 40);
sheet.getCell(1, 0).vAlign(spreadNS.VerticalAlign.center);
sheet.setValue(3, 0, 'The reaction of barium hydroxide with phosphoric acid:', 3);
sheet.setValue(4, 0, reaction, 3);
sheet.setRowHeight(4, 40);
sheet.getCell(4, 0).vAlign(spreadNS.VerticalAlign.center);
sheet.setValue(6, 0, google, 3);
sheet.setRowHeight(6, 50);
sheet.name('Basic Usage');
const listSheet = new GC.Spread.Sheets.Worksheet('List Usage');
spread.addSheet(1, listSheet);
spread.setActiveSheet('List Usage');
listSheet.setColumnWidth(0, 720);
listSheet.setValue(0, 0, 'Steak Wellington Ingredients');
listSheet.setValue(1, 0, ingredients);
listSheet.getCell(1, 0).wordWrap(true);
listSheet.autoFitRow(1);
listSheet.setValue(3, 0, 'Steak Wellington Instructions');
listSheet.setValue(4, 0, instructions);
listSheet.getCell(4, 0).wordWrap(true);
listSheet.autoFitRow(4);
spread.resumePaint();
spread.options.tabStripRatio = 0.8;
}
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/react/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/react/node_modules/@mescius/spread-sheets-designer/styles/gc.spread.sheets.designer.light.min.css"> <!-- SystemJS -->
<script src="$DEMOROOT$/en/react/node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('$DEMOROOT$/en/lib/react/license.js').then(function () {
System.import('./src/app');
});
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
#app {
height: 100%;
}
.description {
margin: 10px;
width: 40%;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-react': 'npm:@mescius/spread-sheets-react/index.js',
'@mescius/spread-sheets-barcode': 'npm:@mescius/spread-sheets-barcode/index.js',
'@mescius/spread-sheets-charts': 'npm:@mescius/spread-sheets-charts/index.js',
'@mescius/spread-sheets-languagepackages': 'npm:@mescius/spread-sheets-languagepackages/index.js',
'@mescius/spread-sheets-print': 'npm:@mescius/spread-sheets-print/index.js',
'@mescius/spread-sheets-pdf': 'npm:@mescius/spread-sheets-pdf/index.js',
'@mescius/spread-sheets-shapes': 'npm:@mescius/spread-sheets-shapes/index.js',
'@mescius/spread-sheets-slicers': 'npm:@mescius/spread-sheets-slicers/index.js',
'@mescius/spread-sheets-formula-panel': 'npm:@mescius/spread-sheets-formula-panel/index.js',
'@mescius/spread-sheets-tablesheet': 'npm:@mescius/spread-sheets-tablesheet/index.js',
'@mescius/spread-sheets-io': 'npm:@mescius/spread-sheets-io/index.js',
'@mescius/spread-sheets-pivot-addon': 'npm:@mescius/spread-sheets-pivot-addon/index.js',
'@mescius/spread-sheets-designer': 'npm:@mescius/spread-sheets-designer/index.js',
'@mescius/spread-sheets-designer-react': 'npm:@mescius/spread-sheets-designer-react/index.js',
'@mescius/spread-sheets-designer-resources-en': 'npm:@mescius/spread-sheets-designer-resources-en/index.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js',
'react': 'npm:react/cjs/react.production.js',
'react-dom': 'npm:react-dom/cjs/react-dom.production.js',
'react-dom/client': 'npm:react-dom/cjs/react-dom-client.production.js',
'scheduler': 'npm:scheduler/cjs/scheduler.production.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);

Rich text data is an anonymous object, you should follow the JSON Schema.
You can set the value for the specified cell in the specified sheet area using the following code:
You can get the unformatted data from the specified cell in the specified sheet area using the following code:
Updated: Rich text now support list
import { Component, NgModule, enableProdMode, ViewEncapsulation} from "@angular/core";
import { BrowserModule } from "@angular/platform-browser";
import GC from "@mescius/spread-sheets";
import { platformBrowserDynamic } from "@angular/platform-browser-dynamic";
import "./styles.css";
import "@mescius/spread-sheets-print";
import "@mescius/spread-sheets-shapes";
import "@mescius/spread-sheets-pivot-addon";
import "@mescius/spread-sheets-tablesheet";
import "@mescius/spread-sheets-io";
import '@mescius/spread-sheets-designer-resources-en';
import '@mescius/spread-sheets-designer';
import { DesignerModule } from "@mescius/spread-sheets-designer-angular";
import {registerlic} from '$DEMOROOT$/spread/source/js/designer/react_vue/license.js';
GC.Spread.Common.CultureManager.culture("en-us");
registerlic(GC);
const spreadNS = GC.Spread.Sheets;
const richEditorHelper = {
toHexColor (color) {
let reg = /^#([0-9a-fA-F]{3}|[0-9a-fA-F]{6})$/;
if (/^(rgb|RGB)/.test(color)) {
let aColor = color.replace(/(?:\(|\)|rgb|RGB)*/g, "").split(",");
let strHex = "#";
for (let i = 0; i < aColor.length; i++) {
let hex = Number(aColor[i]).toString(16);
if (hex.length < 2) {
hex = '0' + hex;
}
strHex += hex;
}
if (strHex.length !== 7) {
strHex = color;
}
return strHex;
} else if (reg.test(color)) {
let aNum = color.replace(/#/, "").split("");
if (aNum.length === 6) {
return color;
} else if (aNum.length === 3) {
let numHex = "#";
for (let i = 0; i < aNum.length; i += 1) {
numHex += (aNum[i] + aNum[i]);
}
return numHex;
}
}
return color;
},
getStandardFont (unStandardFont) {
if (!unStandardFont) {
return;
}
let style = new spreadNS.Style();
style.font = unStandardFont;
let { fontWeight, fontSize } = style;
if (!isNaN(fontWeight)) {
style.fontWeight = +fontWeight >= 700 ? "bold" : "normal";
}
style.fontSize = (fontSize.indexOf("px") > 0) ? (Math.round((+(fontSize.split("px")[0])) * 3 / 4) + "pt") : fontSize;
return style.font;
},
setDefaultStyleToRichItem (richText, font, foreColor, textDecoration) {
richText.style = {
font,
foreColor,
textDecoration
};
},
isNullOrUndefined (value) {
return value === undefined || value === null;
},
composeCurrentRichItemStyleWithActiveCellStyle (richText, cellStyle, theme) {
const currentItemStyle = richText.style;
if (currentItemStyle.foreColor === undefined && !richEditorHelper.isNullOrUndefined(cellStyle.foreColor)) {
currentItemStyle.foreColor = cellStyle.foreColor;
}
if (currentItemStyle.font === undefined && !richEditorHelper.isNullOrUndefined(cellStyle.font)) {
currentItemStyle.font = cellStyle.font;
} else if (currentItemStyle.font) {
currentItemStyle.font = richEditorHelper.getStandardFont(currentItemStyle.font);
}
if (currentItemStyle.textDecoration === undefined && !richEditorHelper.isNullOrUndefined(cellStyle.textDecoration)) {
currentItemStyle.textDecoration = cellStyle.textDecoration;
}
currentItemStyle.foreColor = richEditorHelper.toHexColor(theme.getColor(currentItemStyle.foreColor));
},
splitRichTextByLineBreaker (richText, newRichTexts) {
const currentItemStyle = richText.style;
const wrappedTexts = richText.text.split(/\r?\n/g);
for (let j = 0, wrapperLen = wrappedTexts.length; j < wrapperLen; j++) {
let obj = {};
obj.text = wrappedTexts[j];
obj.style = currentItemStyle;
if (obj.text) {
newRichTexts.push(obj);
}
if (j !== wrapperLen - 1) {
newRichTexts.push({
text: '\r\n',
style: currentItemStyle
});
}
}
},
createRichTextsFromPlainText (sheet, row, col, font, foreColor, textDecoration) {
const text = sheet.getText(row, col);
const wrappedTexts = text.split("\n");
const richTexts = [];
for (let i = 0, len = wrappedTexts.length; i < len; i++) {
if (wrappedTexts[i]) {
richTexts.push({
text: wrappedTexts[i],
style: {
font,
foreColor,
textDecoration
}
});
}
if (i !== len - 1) {
richTexts.push({
text: '\r\n',
style: richTexts[i].style
});
}
}
return richTexts;
},
getRichStyleFromCellStyle (cellStyle, theme) {
return {
font: cellStyle.font,
textDecoration: cellStyle.textDecoration,
foreColor: cellStyle.foreColor
}
},
getRichTextItemsForRichEditor (sheet, row, col) {
const value = sheet.getValue(row, col, spreadNS.SheetArea.viewport, spreadNS.ValueType.richText);
const cellStyle = sheet.getActualStyle(row, col);
const theme = sheet.currentTheme();
if (cellStyle.foreColor && theme) {
cellStyle.foreColor = richEditorHelper.toHexColor(theme.getColor(cellStyle.foreColor));
}
if (!value) {
return [{
text: "",
style: richEditorHelper.getRichStyleFromCellStyle(cellStyle)
}];
}
let richTexts = value.richText;
let foreColor = cellStyle.foreColor || "#000000";
let textDecoration = cellStyle.textDecoration;
let font = cellStyle.font ? richEditorHelper.getStandardFont(cellStyle.font) : "11pt Calibri";
if (richTexts) {
let newRichTexts = [];
for (let i = 0, len = richTexts.length; i < len; i++) {
if (!richTexts[i]) {
continue;
}
if (!richTexts[i].style) {
richEditorHelper.setDefaultStyleToRichItem(richTexts[i], font, foreColor, textDecoration);
} else if (richTexts[i].style) {
richEditorHelper.composeCurrentRichItemStyleWithActiveCellStyle(richTexts[i], cellStyle, theme);
}
if (richTexts[i].text && richTexts[i].text !== "\r\n" && richTexts[i].text !== '\n' && richTexts[i].text.split(/\r?\n/g).length > 1) {
richEditorHelper.splitRichTextByLineBreaker(richTexts[i], newRichTexts);
} else {
newRichTexts.push(richTexts[i]);
}
}
return newRichTexts;
} else {
return richEditorHelper.createRichTextsFromPlainText(sheet, row, col, font, foreColor, textDecoration);
}
}
};
@Component({
selector: "app-component",
templateUrl: "src/app.component.html",
})
export class AppComponent {
spread: GC.Spread.Sheets.Workbook;
props = {
styleInfo: "width: 100%; height: 98vh;",
config: this.getDesignerConfig(),
spreadOptions: { sheetCount: 1 },
};
constructor() { }
initDesigner($event: any) {
let workbook = $event.designer.getWorkbook();
this.spread = workbook;
this.initSpread(workbook);
}
initSpread(spread) {
const lawOfUniversalGravitation = {
richText: [
{
style: {
font: "normal 24px Calibri"
},
text: "F = (G * M"
},
{
style: {
font: "normal 24px Calibri",
vertAlign: 2
},
text: "1"
},
{
style: {
font: "normal 24px Calibri"
},
text: " * M"
},
{
style: {
font: "normal 24px Calibri",
vertAlign: 2
},
text: "2"
},
{
style: {
font: "normal 24px Calibri"
},
text: ") / R"
},
{
style: {
font: "normal 24px Calibri",
vertAlign: 1
},
text: "2"
}
]
};
const reaction = {
richText: [
{
style: {
font: "normal 24px Calibri"
},
text: "3 Ba(OH)"
},
{
style: {
font: "normal 24px Calibri",
vertAlign: 2
},
text: "2"
},
{
style: {
font: "normal 24px Calibri"
},
text: " + 2 H"
},
{
style: {
font: "normal 24px Calibri",
vertAlign: 2
},
text: "3"
},
{
style: {
font: "normal 24px Calibri"
},
text: "PO"
},
{
style: {
font: "normal 24px Calibri",
vertAlign: 2
},
text: "4"
},
{
style: {
font: "normal 24px Calibri"
},
text: " → 6 H"
},
{
style: {
font: "normal 24px Calibri",
vertAlign: 2
},
text: "2"
},
{
style: {
font: "normal 24px Calibri"
},
text: "O + Ba"
},
{
style: {
font: "normal 24px Calibri",
vertAlign: 2
},
text: "3"
},
{
style: {
font: "normal 24px Calibri"
},
text: "(PO"
},
{
style: {
font: "normal 24px Calibri",
vertAlign: 2
},
text: "4"
},
{
style: {
font: "normal 24px Calibri"
},
text: ")"
},
{
style: {
font: "normal 24px Calibri",
vertAlign: 2
},
text: "2"
},
{
style: {
font: "normal 24px Calibri"
},
text: "↓"
}
]
};
const google = {
richText: [
{
style: {
font: "bold 36px Calibri",
foreColor: "rgb(78,133,242)"
},
text: "G"
},
{
style: {
font: "bold 36px Calibri",
foreColor: "rgb(228,65,52)"
},
text: "o"
},
{
style: {
font: "bold 36px Calibri",
foreColor: "rgb(247,188,32)"
},
text: "o"
},
{
style: {
font: "bold 36px Calibri",
foreColor: "rgb(78,133,242)"
},
text: "g"
},
{
style: {
font: "bold 36px Calibri",
foreColor: "rgb(65,168,87)"
},
text: "l"
},
{
style: {
font: "bold 36px Calibri",
foreColor: "rgb(228,65,52)"
},
text: "e"
}
]
};
const ingredients = {
richText: [{
type: GC.Spread.Sheets.ListType.disc,
richText: [{
text: "4 beef fillet steaks (about 6 ounces each)"
}]
}, {
type: GC.Spread.Sheets.ListType.disc,
richText: [{
text: "Salt and black pepper, to taste"
}]
}, {
type: GC.Spread.Sheets.ListType.disc,
richText: [{
text: "2 tablespoons olive oil"
}]
}, {
type: GC.Spread.Sheets.ListType.disc,
richText: [{
text: "2 tablespoons Dijon mustard"
}]
}, {
type: GC.Spread.Sheets.ListType.disc,
richText: [{
text: "8 slices of prosciutto or Parma ham"
}]
}, {
type: GC.Spread.Sheets.ListType.disc,
richText: [{
text: "1 package (17.3 ounces) puff pastry, thawed"
}]
}, {
type: GC.Spread.Sheets.ListType.disc,
richText: [{
text: "1 egg, beaten (for egg wash)"
}]
}, {
type: GC.Spread.Sheets.ListType.disc,
richText: [{
text: "Mushroom Duxelles:"
}]
}, {
type: GC.Spread.Sheets.ListType.circle,
level: 1,
richText: [{
text: "2 tablespoons butter"
}]
}, {
type: GC.Spread.Sheets.ListType.circle,
level: 1,
richText: [{
text: "1 shallot, finely chopped"
}]
}, {
type: GC.Spread.Sheets.ListType.circle,
level: 1,
richText: [{
text: "8 ounces mushrooms, finely chopped"
}]
}, {
type: GC.Spread.Sheets.ListType.circle,
level: 1,
richText: [{
text: "2 cloves garlic, minced"
}]
}, {
type: GC.Spread.Sheets.ListType.circle,
level: 1,
richText: [{
text: "2 sprigs fresh thyme, leaves only"
}]
}, {
type: GC.Spread.Sheets.ListType.circle,
level: 1,
richText: [{
text: "Salt and black pepper, to taste"
}]
}]
};
const instructions = {
richText: [{
type: GC.Spread.Sheets.ListType.decimal,
richText: [{
text: "Preheat the oven to 400°F (200°C)."
}]
}, {
type: GC.Spread.Sheets.ListType.decimal,
richText: [{
text: "Season the beef fillet steaks with salt and black pepper on both sides."
}]
}, {
type: GC.Spread.Sheets.ListType.decimal,
richText: [{
text: "Heat olive oil in a skillet over high heat. Sear the steaks for about 1-2 minutes on each side until browned. Remove from heat and let them cool."
}]
}, {
type: GC.Spread.Sheets.ListType.decimal,
richText: [{
text: "Prepare the mushroom duxelles: In the same skillet, melt butter over medium heat. Add the shallot and cook until softened. Add the mushrooms, garlic, and thyme. Cook until the mushrooms release their moisture and it evaporates. Season with salt and black pepper. Remove from heat and let it cool."
}]
}, {
type: GC.Spread.Sheets.ListType.decimal,
richText: [{
text: "On a clean surface, spread out the slices of prosciutto or Parma ham in a slightly overlapping manner to form a rectangle large enough to wrap each steak."
}]
}, {
type: GC.Spread.Sheets.ListType.decimal,
richText: [{
text: "Spread a thin layer of Dijon mustard over the cooled steaks. Place each steak on top of a prosciutto rectangle."
}]
}, {
type: GC.Spread.Sheets.ListType.decimal,
richText: [{
text: "Spoon the mushroom duxelles evenly over each steak."
}]
}, {
type: GC.Spread.Sheets.ListType.decimal,
richText: [{
text: "Carefully wrap the prosciutto and mushroom-covered steaks with the puff pastry, ensuring the seams are sealed. Trim off any excess pastry."
}]
}, {
type: GC.Spread.Sheets.ListType.decimal,
richText: [{
text: "Place the wrapped steaks on a baking sheet lined with parchment paper. Brush the puff pastry with beaten egg to create a golden crust."
}]
}, {
type: GC.Spread.Sheets.ListType.decimal,
richText: [{
text: "Bake in the preheated oven for about 20-25 minutes, or until the puff pastry is golden brown and the steak is cooked to your desired doneness. For medium-rare, the internal temperature should be around 130-135°F (55-57°C)."
}]
}, {
type: GC.Spread.Sheets.ListType.decimal,
richText: [{
text: "Remove from the oven and let the Steak Wellington rest for a few minutes before serving."
}]
}, {
type: GC.Spread.Sheets.ListType.decimal,
richText: [{
text: "Serve the Steak Wellington sliced, and enjoy it with your favorite sides like roasted potatoes, steamed vegetables, or a green salad."
}]
}]
};
spread.suspendPaint();
const sheet = spread.sheets[0];
sheet.setColumnWidth(0, 720);
sheet.setValue(0, 0, 'Law of universal gravitation:', 3);
sheet.setValue(1, 0, lawOfUniversalGravitation, 3);
sheet.setRowHeight(1, 40);
sheet.getCell(1, 0).vAlign(spreadNS.VerticalAlign.center);
sheet.setValue(3, 0, 'The reaction of barium hydroxide with phosphoric acid:', 3);
sheet.setValue(4, 0, reaction, 3);
sheet.setRowHeight(4, 40);
sheet.getCell(4, 0).vAlign(spreadNS.VerticalAlign.center);
sheet.setValue(6, 0, google, 3);
sheet.setRowHeight(6, 50);
sheet.name('Basic Usage');
const listSheet = new GC.Spread.Sheets.Worksheet('List Usage');
spread.addSheet(1, listSheet);
spread.setActiveSheet('List Usage');
listSheet.setColumnWidth(0, 720);
listSheet.setValue(0, 0, 'Steak Wellington Ingredients');
listSheet.setValue(1, 0, ingredients);
listSheet.getCell(1, 0).wordWrap(true);
listSheet.autoFitRow(1);
listSheet.setValue(3, 0, 'Steak Wellington Instructions');
listSheet.setValue(4, 0, instructions);
listSheet.getCell(4, 0).wordWrap(true);
listSheet.autoFitRow(4);
spread.resumePaint();
spread.options.tabStripRatio = 0.8;
}
getDesignerConfig() {
GC.Spread.Sheets.Designer.registerTemplate("richEditor", {
content: [{
type: "RichTextEditor",
bindingPath: "value",
editorWidth: "640px",
editorHeight: "542px",
onChange: (value, spread) => {
if (!spread || !value) {
return;
}
let sheet = spread.getActiveSheet();
sheet.setValue(sheet.getActiveRowIndex(), sheet.getActiveColumnIndex(), value.value);
}
}]
});
const richEditorPanel = {
position: "right",
width: "640px",
command: "richEditor",
uiTemplate: "richEditor"
};
let oldSheetName, oldRow, oldCol, oldValue;
const richEditorCommand = {
commandName: 'richEditor',
getState: (context) => {
const spread = context.getWorkbook(), activeSheet = spread.getActiveSheet(), activeRow = activeSheet.getActiveRowIndex(), activeCol = activeSheet.getActiveColumnIndex();
// only when change active cell, need to reset editor content
if (oldSheetName === activeSheet.name() && oldRow === activeRow && oldCol === activeCol) {
return oldValue;
}
oldSheetName = activeSheet.name();
oldRow = activeRow;
oldCol = activeCol;
const richTextItems = richEditorHelper.getRichTextItemsForRichEditor(activeSheet, activeRow, activeCol);
oldValue = {
value: {
value: {
richText: richTextItems
},
style: activeSheet.getActualStyle(activeRow, activeCol)
}
};
return oldValue;
}
}
return {
contextMenu: [],
ribbon: [],
sidePanels: [richEditorPanel],
commandMap: {
richEditor: richEditorCommand
}
};
}
}
@NgModule({
imports: [BrowserModule, DesignerModule],
declarations: [AppComponent],
exports: [AppComponent],
bootstrap: [AppComponent],
encapsulation: ViewEncapsulation.None
})
export class AppModule { }
enableProdMode();
// Bootstrap application with hash style navigation and global services.
platformBrowserDynamic().bootstrapModule(AppModule);
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/angular/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/angular/node_modules/@mescius/spread-sheets-designer/styles/gc.spread.sheets.designer.light.min.css">
<!-- Polyfills -->
<script src="$DEMOROOT$/en/angular/node_modules/core-js/client/shim.min.js"></script>
<script src="$DEMOROOT$/en/angular/node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/angular/node_modules/systemjs/dist/system.js"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.import('@angular/compiler');
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('$DEMOROOT$/en/lib/angular/license.ts');
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="sample-tutorial">
<designer [props]="props" (designerInitialized)="initDesigner($event)"></designer>
</div>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
#app {
height: 100%;
}
.gc-designer-container {
height: 100%;
}
.description {
margin: 10px;
width: 40%;
}
(function (global) {
System.config({
transpiler: 'ts',
typescriptOptions: {
tsconfig: true
},
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'core-js': 'npm:core-js/client/shim.min.js',
'zone': 'npm:zone.js/fesm2015/zone.min.js',
'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js',
'@angular/core': 'npm:@angular/core/fesm2022',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
'jszip': 'npm:jszip/dist/jszip.min.js',
'typescript': 'npm:typescript/lib/typescript.js',
'ts': './plugin.js',
'tslib': 'npm:tslib/tslib.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-angular': 'npm:@mescius/spread-sheets-angular/fesm2020/mescius-spread-sheets-angular.mjs',
'@mescius/spread-sheets-barcode': 'npm:@mescius/spread-sheets-barcode/index.js',
'@mescius/spread-sheets-charts': 'npm:@mescius/spread-sheets-charts/index.js',
'@mescius/spread-sheets-languagepackages': 'npm:@mescius/spread-sheets-languagepackages/index.js',
'@mescius/spread-sheets-print': 'npm:@mescius/spread-sheets-print/index.js',
'@mescius/spread-sheets-pdf': 'npm:@mescius/spread-sheets-pdf/index.js',
'@mescius/spread-sheets-shapes': 'npm:@mescius/spread-sheets-shapes/index.js',
'@mescius/spread-sheets-io': 'npm:@mescius/spread-sheets-io/index.js',
'@mescius/spread-sheets-slicers': 'npm:@mescius/spread-sheets-slicers/index.js',
'@mescius/spread-sheets-pivot-addon': 'npm:@mescius/spread-sheets-pivot-addon/index.js',
'@mescius/spread-sheets-tablesheet': 'npm:@mescius/spread-sheets-tablesheet/index.js',
'@mescius/spread-sheets-formula-panel': 'npm:@mescius/spread-sheets-formula-panel/index.js',
'@mescius/spread-sheets-designer': 'npm:@mescius/spread-sheets-designer/index.js',
'@mescius/spread-sheets-designer-resources-en': 'npm:@mescius/spread-sheets-designer-resources-en/index.js',
'@mescius/spread-sheets-designer-angular': 'npm:@mescius/spread-sheets-designer-angular/fesm2020/mescius-spread-sheets-designer-angular.mjs',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js',
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'ts'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
"node_modules/@angular": {
defaultExtension: 'mjs'
},
"@mescius/spread-sheets-angular": {
defaultExtension: 'mjs'
},
"@mescius/spread-sheets-designer-angular": {
defaultExtension: 'mjs'
},
'@angular/core': {
defaultExtension: 'mjs',
main: 'core.mjs'
}
}
});
})(this);